package com.gmail.sg06.greenrevolution.data;

import java.util.HashMap;

public class SeerCOData extends COData {

	public SeerCOData(int day, int turn, boolean isCO) {
		super(day, turn, isCO);
	}

	/**
	 * n 日目の結果！
	 *
	 * @param day 知りたい日にち
	 * @return エージェントindex 占い結果が無い場合は -1
	 */
	public int getAgent(int day) {

		if (getKnownList().size() < day) {
			return -1;
		}

		return getKnownList().get(day);
	}


	/**
	 * n 日目の結果！
	 *
	 * @param day
	 * @return 結果を言ったエージェント番号と黒だったかのマップ. 結果を言っていなければ, null を返す.
	 *
	 */
	public HashMap<Integer, Boolean> getResult(int day){
		for (int i = 0; i < getDayList().size(); i++ ){
			if ( getDayList().get(i) == day ){
				HashMap<Integer, Boolean> result = new HashMap<Integer, Boolean>();
				result.put(getKnownList().get(i), getIsBlackList().get(i));
				return result;
			}
		}
		return null;
	}


	/**
	 * すべての日の分結果を言ったかどうか
	 * 注) その日の最初に呼ぶべきではない！結果を言うのが２ターン目だったり，
	 * 遅れてCOして，まとめて結果を言っている最中かもしれないので，
	 * 使うならtalkが全て終わってから！！
	 * @param day 現在の日にち
	 * @return
	 */
	public boolean isFullResult(int day) {
		if (getIsBlackList().size() != day) {
			return false;
		}
		return true;
	}

}
