package com.gmail.sg06.greenrevolution.jingai_table;

import java.util.ArrayList;
import java.util.Set;

import org.aiwolf.common.data.Agent;
import org.aiwolf.common.data.Role;
import org.aiwolf.common.net.GameInfo;

import com.gmail.sg06.greenrevolution.data.COData;

public class JuN1JingaiTable2 extends AbstractJingaiTable{


// LGJingaiTable から変更する割合をフィールド変数ではなく, その場で設定して使用する

// 変更割合 ソースコードで上から順に
	private final double[] BASIC_RATES = {0.0001,		// 襲撃
			0.9, 0.7, 0.5,							// 投票
			0.05, 0.05, 0.9, 0.7, 0.2,				// 占い先
			0.05, 0.05, 							// 霊能先
			0.05, 0.05, 0.05, 0.005,				// 占い CO
			0.05, 0.05, 0.05, 0.01,				// 霊能 CO
			0.7,									// 狩人 CO
			0.5, 0.7,								// CO していない
			0.002, 0.9								// パターン
			};

	public ArrayList<ArrayList<Integer>> agentMemory_;		// 割合を変更したエージェントの組合せ
	public ArrayList<ArrayList<Role>>    roleMemory_;		// 割合を変更した役職の組合せ
	public ArrayList<Integer>            infoMemory_;		// 割合を変更した条件の組合せ

/**
 * コンストラクタ
 */
	public JuN1JingaiTable2(){
		super();
		setRates(BASIC_RATES);
		agentMemory_ = new ArrayList<ArrayList<Integer>>();
		roleMemory_  = new ArrayList<ArrayList<Role>>();
		infoMemory_  = new ArrayList<Integer>();

//		System.out.print("START : ");
//		for ( int i = 0; i < getRates().length; i++ ){
//			System.out.print(getRate(i) + " , ");
//		}
//		System.out.println();
//		System.out.println(Math.pow(3.0, 0.01));
//		System.out.println(Math.pow(0.8, 0.01));


	}

	@Override
	public void calcAttackInfo(int targetIdx) {
	// 襲撃先が人狼
		ArrayList<Integer> list = tableIndexList(targetIdx, Role.WEREWOLF);
		int    changeNum = 0;
		double rate      = getRate(changeNum);
		for(Integer i: list){
			getRateTable()[i][0] *= rate;
		}
	}





	@Override
	public void calcVoteInfo(int agentIdx, int targetIdx) {
		ArrayList<Integer> list;;
		int    changeNum;
		double rate;

		ArrayList<Integer> agents = new ArrayList<Integer>();
		ArrayList<Role>    roles  = new ArrayList<Role>();
	// 狂人が人狼に投票
//		list      = tableIndexList(agentIdx, Role.POSSESSED, targetIdx, Role.WEREWOLF);
//		changeNum = 1;
//		rate      = getRate(changeNum);
//		for(Integer i: list){
//			getRateTable()[i][0] *= rate;
//		}
//		agents.clear();
//		roles.clear();
//		agents.add(agentIdx);
//		roles.add(Role.POSSESSED);
//		agents.add(targetIdx);
//		roles.add(Role.WEREWOLF);
//		setMemory(agents, roles, changeNum);

	// 人狼が狂人に投票
		list      = tableIndexList(agentIdx, Role.WEREWOLF, targetIdx, Role.POSSESSED);
		changeNum = 2;
		rate      = getRate(changeNum);
		for(Integer i: list){
			getRateTable()[i][0] *= rate;
		}
		agents.clear();
		roles.clear();
		agents.add(agentIdx);
		roles.add(Role.WEREWOLF);
		agents.add(targetIdx);
		roles.add(Role.POSSESSED);
		setMemory(agents, roles, changeNum);

	// 人狼が人狼に投票
		list      = tableIndexList(agentIdx, Role.WEREWOLF, targetIdx, Role.WEREWOLF);
		changeNum = 3;
		rate      = getRate(changeNum);
		for(Integer i: list){
			getRateTable()[i][0] *= rate;
		}
		agents.clear();
		roles.clear();
		agents.add(agentIdx);
		roles.add(Role.WEREWOLF);
		agents.add(targetIdx);
		roles.add(Role.WEREWOLF);
		setMemory(agents, roles, changeNum);
	}


	public void calcVoteInfo(int agentIdx, int targetIdx, int day){
		ArrayList<Integer> list;;
		int    changeNum;
		double rate;

		ArrayList<Integer> agents = new ArrayList<Integer>();
		ArrayList<Role>    roles  = new ArrayList<Role>();
	// 狂人が人狼に投票
//		list      = tableIndexList(agentIdx, Role.POSSESSED, targetIdx, Role.WEREWOLF);
//		changeNum = 1;
//		rate      = Math.max(getRate(changeNum) - (0.01*day), 0.0);
//		for(Integer i: list){
//			getRateTable()[i][0] *= rate;
//		}
//		agents.clear();
//		roles.clear();
//		agents.add(agentIdx);
//		roles.add(Role.POSSESSED);
//		agents.add(targetIdx);
//		roles.add(Role.WEREWOLF);
//		setMemory(agents, roles, changeNum);

	// 人狼が狂人に投票
		list      = tableIndexList(agentIdx, Role.WEREWOLF, targetIdx, Role.POSSESSED);
		changeNum = 2;
		rate      = Math.max(getRate(changeNum) - (0.05*day), 0.0);
		for(Integer i: list){
			getRateTable()[i][0] *= rate;
		}
		agents.clear();
		roles.clear();
		agents.add(agentIdx);
		roles.add(Role.WEREWOLF);
		agents.add(targetIdx);
		roles.add(Role.POSSESSED);
		setMemory(agents, roles, changeNum);

	// 人狼が人狼に投票
		list      = tableIndexList(agentIdx, Role.WEREWOLF, targetIdx, Role.WEREWOLF);
		changeNum = 3;
		rate      = Math.max(getRate(changeNum) + (0.05*day), 1.0);
		for(Integer i: list){
			getRateTable()[i][0] *= rate;
		}
		agents.clear();
		roles.clear();
		agents.add(agentIdx);
		roles.add(Role.WEREWOLF);
		agents.add(targetIdx);
		roles.add(Role.WEREWOLF);
		setMemory(agents, roles, changeNum);
	}





	@Override
	public void calcDivineInfo(int agentIdx, int targetIdx, boolean isBlack) {
		ArrayList<Integer> list;
		int    changeNum;
		double rate;

		ArrayList<Integer> agents = new ArrayList<Integer>();
		ArrayList<Role>    roles  = new ArrayList<Role>();
	// 白出しの場合
		if(!isBlack){
		// 村人陣営が人狼を白出し
			list      = tableIndexList(agentIdx, Role.SEER, targetIdx, Role.WEREWOLF);//村人陣営が人狼を白出し
			changeNum = 4;
			rate      = getRate(changeNum);
			for(Integer i: list){
				getRateTable()[i][1] *= rate;
			}
			agents.clear();
			roles.clear();
			agents.add(agentIdx);
			roles.add(Role.SEER);
			agents.add(targetIdx);
			roles.add(Role.WEREWOLF);
			setMemory(agents, roles, changeNum);
		}

	// 黒出しの場合
		else{
		// 村人陣営が村人陣営に黒出し
			list      = tableIndexList(agentIdx, Role.SEER, targetIdx, Role.VILLAGER);
			changeNum = 5;
			rate      = getRate(changeNum);
			for(Integer i: list){
				getRateTable()[i][1] *= rate;
			}
			agents.clear();
			roles.clear();
			agents.add(agentIdx);
			roles.add(Role.SEER);
			agents.add(targetIdx);
			roles.add(Role.VILLAGER);
			setMemory(agents, roles, changeNum);

		// 狂人が人狼に黒出し
//			list      = tableIndexList(agentIdx, Role.POSSESSED, targetIdx, Role.WEREWOLF);
//			changeNum = 6;
//			rate      = getRate(changeNum);
//			for(Integer i: list){
//				getRateTable()[i][1] *= rate;
//			}
//			agents.clear();
//			roles.clear();
//			agents.add(agentIdx);
//			roles.add(Role.POSSESSED);
//			agents.add(targetIdx);
//			roles.add(Role.WEREWOLF);
//			setMemory(agents, roles, changeNum);

		// 人狼が狂人に黒出し
			list      = tableIndexList(agentIdx, Role.WEREWOLF, targetIdx, Role.POSSESSED);
			changeNum = 7;
			rate      = getRate(changeNum);
			for(Integer i: list){
				getRateTable()[i][1] *= rate;
			}
			agents.clear();
			roles.clear();
			agents.add(agentIdx);
			roles.add(Role.WEREWOLF);
			agents.add(targetIdx);
			roles.add(Role.POSSESSED);
			setMemory(agents, roles, changeNum);

		// 人狼が人狼に黒出し
			list      = tableIndexList(agentIdx, Role.WEREWOLF, targetIdx, Role.WEREWOLF);
			changeNum = 8;
			rate      = getRate(changeNum);
			for(Integer i: list){
				getRateTable()[i][1] *= rate;
			}
			agents.clear();
			roles.clear();
			agents.add(agentIdx);
			roles.add(Role.WEREWOLF);
			agents.add(targetIdx);
			roles.add(Role.WEREWOLF);
			setMemory(agents, roles, changeNum);
		}
	}





	@Override
	public void calcInquestInfo(int agentIdx, int targetIdx, boolean isBlack) {
		ArrayList<Integer> list;
		int    changeNum;
		double rate;

		ArrayList<Integer> agents = new ArrayList<Integer>();
		ArrayList<Role>    roles  = new ArrayList<Role>();
	// 白出しの場合
		if(!isBlack){
		// 村人陣営が人狼に白出し
			list      = tableIndexList(agentIdx, Role.MEDIUM, targetIdx, Role.WEREWOLF);
			changeNum = 9;
			rate      = getRate(changeNum);
			for(Integer i: list){
				getRateTable()[i][1] *= rate;
			}
			agents.clear();
			roles.clear();
			agents.add(agentIdx);
			roles.add(Role.MEDIUM);
			agents.add(targetIdx);
			roles.add(Role.WEREWOLF);
			setMemory(agents, roles, changeNum);
		}

	// 黒出しの場合
		else{
		// 村人陣営が村人陣営に黒出し
			list      = tableIndexList(agentIdx, Role.MEDIUM, targetIdx, Role.VILLAGER);
			changeNum = 10;
			rate      = getRate(changeNum);
			for(Integer i: list){
				getRateTable()[i][1] *= rate;
			}
			agents.clear();
			roles.clear();
			agents.add(agentIdx);
			roles.add(Role.MEDIUM);
			agents.add(targetIdx);
			roles.add(Role.VILLAGER);
			setMemory(agents, roles, changeNum);
		}
	}





	@Override
	public void calcSeerCOInfo(ArrayList<Integer> seerCOList) {
		ArrayList<Integer> list;
		int    changeNum;
		double rate;

	// 人狼陣営からのみ占いCOがされている場合
	// 全人狼陣営が占いCOしている場合
		if ( (WOLF_NUM+POS_NUM) == seerCOList.size() ){
			ArrayList<Role> roleList = new ArrayList<Role>();
			for ( int i = 0; i < (WOLF_NUM+POS_NUM); i++ ){
				for ( int j = 0; j < (WOLF_NUM+POS_NUM); j++ ){
					if ( i == j ){
						roleList.add(Role.POSSESSED);
					}else{
						roleList.add(Role.WEREWOLF);
					}
				}
				list      = tableIndexList(seerCOList, roleList);
				changeNum = 11;
				rate = getRate(changeNum);
				for ( int idx : list ){
					getRateTable()[idx][1] *= rate;
				}
				setMemory(seerCOList, roleList, changeNum);
			}
	// 全人狼陣営が占いCOしているわけではない場合
		}else if ( (WOLF_NUM+POS_NUM) > seerCOList.size() ){
		// 狂人を含まないパターン
			ArrayList<Role> roleList = new ArrayList<Role>();
			for ( int i = 0; i < seerCOList.size(); i++ ){
				roleList.add(Role.WEREWOLF);
			}
			list      = tableIndexList(seerCOList, roleList);
			changeNum = 12;
			rate      = getRate(changeNum);
			for ( int idx : list ){
				getRateTable()[idx][1] *= rate;
			}
			setMemory(seerCOList, roleList, changeNum);
		// 狂人を含むパターン
			for ( int i = 0; i < seerCOList.size(); i++ ){
				roleList = new ArrayList<Role>();
				for ( int j = 0; j < seerCOList.size(); j++ ){
					if ( i == j ){
						roleList.add(Role.POSSESSED);
					}else{
						roleList.add(Role.WEREWOLF);
					}
				}
				list      = tableIndexList(seerCOList, roleList);
				changeNum = 13;
				rate = getRate(changeNum);
				for ( int idx : list ){
					getRateTable()[idx][1] *= rate;
				}
				setMemory(seerCOList, roleList, changeNum);
			}
		}

	// 村人陣営から占いCOが 2以上 の場合
	// 一度の更新で重複して更新される組合せがあるが, 現在は無視
		ArrayList<Integer> agentIdxList = new ArrayList<Integer>();
		ArrayList<Role>    roleList     = new ArrayList<Role>();
		for ( int i = 0; i < seerCOList.size()-1; i++ ){
			agentIdxList.clear();
			roleList.clear();
			for ( int j = i+1; j < seerCOList.size(); j++ ){
				agentIdxList.add(seerCOList.get(i));
				roleList.add(Role.VILLAGER);
				agentIdxList.add(seerCOList.get(j));
				roleList.add(Role.VILLAGER);
				list      = tableIndexList(agentIdxList, roleList);
				changeNum = 14;
				rate      = getRate(changeNum);
				for ( int idx : list ){
					getRateTable()[idx][1] *= rate;
				}
				setMemory(agentIdxList, roleList, changeNum);
			}
		}
	}





	@Override
	public void calcMediumCOInfo(ArrayList<Integer> mediumCOList) {
		ArrayList<Integer> list;
		int    changeNum;
		double rate;

	// 人狼陣営からのみ霊能COがされている場合
	// 全人狼陣営が霊能COしている場合
		if ( (WOLF_NUM+POS_NUM) == mediumCOList.size() ){
			ArrayList<Role> roleList = new ArrayList<Role>();
			for ( int i = 0; i < (WOLF_NUM+POS_NUM); i++ ){
				for ( int j = 0; j < (WOLF_NUM+POS_NUM); j++ ){
					if ( i == j ){
						roleList.add(Role.POSSESSED);
					}else{
						roleList.add(Role.WEREWOLF);
					}
				}
				list      = tableIndexList(mediumCOList, roleList);
				changeNum = 15;
				rate      = getRate(changeNum);
				for ( int idx : list ){
					getRateTable()[idx][1] *= rate;
				}
				setMemory(mediumCOList, roleList, changeNum);
			}

	// 全人狼陣営が霊能COしているわけではない場合
		}else if ( (WOLF_NUM+POS_NUM) > mediumCOList.size() ){
		// 狂人を含まないパターン
			ArrayList<Role> roleList = new ArrayList<Role>();
//			for ( int i = 0; i < mediumCOList.size(); i++ ){
//				roleList.add(Role.WEREWOLF);
//			}
//			list      = tableIndexList(mediumCOList, roleList);
//			changeNum = 16;
//			rate      = getRate(changeNum);
//			for ( int idx : list ){
//				getRateTable()[idx][1] *= rate;
//			}
//			setMemory(mediumCOList, roleList, changeNum);
		// 狂人を含むパターン
			for ( int i = 0; i < mediumCOList.size(); i++ ){
				roleList = new ArrayList<Role>();
				for ( int j = 0; j < mediumCOList.size(); j++ ){
					if ( i == j ){
						roleList.add(Role.POSSESSED);
					}else{
						roleList.add(Role.WEREWOLF);
					}
				}
				list      = tableIndexList(mediumCOList, roleList);
				changeNum = 17;
				rate      = getRate(changeNum);
				for ( int idx : list ){
					getRateTable()[idx][1] *= rate;
				}
				setMemory(mediumCOList, roleList, changeNum);
			}
		}

	// 村人陣営から霊能COが 2 の場合
	// 一度の更新で重複して更新される組合せがあるが, 現在は無視
		ArrayList<Integer> agentIdxList = new ArrayList<Integer>();
		ArrayList<Role>    roleList     = new ArrayList<Role>();
		for ( int i = 0; i < mediumCOList.size()-1; i++ ){
			agentIdxList.clear();
			roleList.clear();
			for ( int j = i+1; j < mediumCOList.size(); j++ ){
				agentIdxList.add(mediumCOList.get(i));
				roleList.add(Role.VILLAGER);
				agentIdxList.add(mediumCOList.get(j));
				roleList.add(Role.VILLAGER);
				list      = tableIndexList(agentIdxList, roleList);
				changeNum = 18;
				rate      = getRate(changeNum);
				for ( int idx : list ){
					getRateTable()[idx][1] *= rate;
				}
				setMemory(agentIdxList, roleList, changeNum);
			}
		}
	}





	@Override
	public void calcBGCOInfo(ArrayList<Integer> BGCOList) {
		ArrayList<Integer> list;
		int    changeNum;
		double rate;

// ありえそうなので, 倍率をかなり上げた.

	// 村人陣営から狩COが 2 の場合
	// 一度の更新で重複して更新される組合せがあるが, 現在は無視
		ArrayList<Integer> agentIdxList = new ArrayList<Integer>();
		ArrayList<Role>    roleList     = new ArrayList<Role>();
		for ( int i = 0; i < BGCOList.size()-1; i++ ){
			agentIdxList.clear();
			roleList.clear();
			for ( int j = i+1; j < BGCOList.size(); j++ ){
				agentIdxList.add(BGCOList.get(i));
				roleList.add(Role.VILLAGER);
				agentIdxList.add(BGCOList.get(j));
				roleList.add(Role.VILLAGER);
				list      = tableIndexList(agentIdxList, roleList);
				changeNum = 19;
				rate      = getRate(changeNum);
				for ( int idx : list ){
					getRateTable()[idx][1] *= rate;
				}
				setMemory(agentIdxList, roleList, changeNum);
			}
		}
	}





	@Override
	public void calcNotCOInfo(ArrayList<Integer> notCOList) {
		ArrayList<Integer> list;
		int    changeNum;
		double rate;

		ArrayList<Integer> agents = new ArrayList<Integer>();
		ArrayList<Role>    roles  = new ArrayList<Role>();
	// 狂人がCOしない
		for ( int i = 0; i < notCOList.size(); i++) {
			list      = tableIndexList(notCOList.get(i), Role.POSSESSED);
			changeNum = 20;
			rate      = getRate(changeNum);
			for ( int idx : list ){
				getRateTable()[idx][1] *= rate;
			}
			agents.clear();
			roles.clear();
			agents.add(notCOList.get(i));
			roles.add(Role.POSSESSED);
			setMemory(agents, roles, changeNum);
		}

	// COしていないエージェントがすべて村人陣営
		ArrayList<Role> roleList = new ArrayList<Role>();
		for ( int i = 0; i < notCOList.size(); i++ ){
			roleList.add(Role.VILLAGER);
		}
		list      = tableIndexList(notCOList, roleList);
		changeNum = 21;
		rate      = getRate(changeNum);
		for ( int idx : list ){
			getRateTable()[idx][1] *= rate;
		}
		setMemory(notCOList, roleList, changeNum);

	}





	/**
	 * 占いと霊能の組合せの矛盾による人外テーブルの更新
	 *
	 * @param seerIdx 占い CO のエージェント番号
	 * @param seerCOData 占い CO のこれまでの結果
	 * @param mediumIdx  霊能 CO のエージェント番号
	 * @param mediumCOData 霊能 CO のこれまでの結果
	 */
	public void calcPatternInfo(int seerIdx, COData seerCOData, int mediumIdx, COData mediumCOData){
		ArrayList<Integer> list;
		int    changeNum;
		double rate;

	// 占いと霊能で結果が異なる場合
		ArrayList<Integer> seerWhiteList   = seerCOData.getWhiteList();
		ArrayList<Integer> mediumWhiteList = mediumCOData.getWhiteList();
		ArrayList<Integer> seerBlackList   = seerCOData.getBlackList();
		ArrayList<Integer> mediumBlackList = mediumCOData.getBlackList();
		boolean isFake  = false;

	// 占い --> 白, 霊能 --> 黒
		for ( int idx : seerWhiteList ){
			if ( mediumBlackList.contains(idx) ){
				isFake = true;
				break;
			}
		}

	// 占い --> 黒, 霊能 --> 白
		for ( int idx : seerBlackList ){
			if ( mediumWhiteList.contains(idx) ){
				isFake = true;
				break;
			}
		}

		if ( isFake ){
			ArrayList<Integer> agentList = new ArrayList<Integer>();
			agentList.add(seerIdx);
			agentList.add(mediumIdx);

			ArrayList<Role> roleList1 = new ArrayList<Role>();
			roleList1.add(Role.VILLAGER);
			roleList1.add(Role.VILLAGER);
			list      = tableIndexList(agentList, roleList1);
			changeNum = 22;
			rate      = getRate(changeNum);
			for ( int idx : list ){
				getRateTable()[idx][1] *= rate;
			}
			setMemory(agentList, roleList1, changeNum);

			ArrayList<Role> roleList2 = new ArrayList<Role>();
			roleList2.add(Role.WEREWOLF);
			roleList2.add(Role.WEREWOLF);
			list      = tableIndexList(agentList, roleList1);
			changeNum = 23;
			rate      = getRate(changeNum);
			for ( int idx : list ){
				getRateTable()[idx][1] *= rate;
			}
			setMemory(agentList, roleList2, changeNum);
		}
	}





	public void setMemory(ArrayList<Integer> agents, ArrayList<Role> roles, int info){
		boolean agentSame = false;
		boolean infoSame  = false;
		for ( int i = 0; i < agentMemory_.size(); i++ ){
			ArrayList<Integer> memory  = agentMemory_.get(i);
			if ( agents.size() == memory.size() ){
				for ( int j = 0; j < agents.size(); j++ ){
					if ( agents.get(j) != memory.get(j) ){
						agentSame = false;
						break;
					}
					agentSame = true;
				}
			}
			if ( agentSame ){
				if ( info == infoMemory_.get(i) ){
					infoSame = true;
					break;
				}
			}
		}

		if ( !agentSame || !infoSame ){
			agentMemory_.add(agents);
			roleMemory_.add(roles);
			infoMemory_.add(info);
		}
	}






/**
 *
 * @param gameInfo
 */
	public void learningChangeRate(GameInfo gameInfo){
//		int n = 0;
//		int m = 0;

		double[] missList = new double[BASIC_RATES.length];
		for ( int i = 0; i < missList.length; i++ ){
			missList[i] = 1.0;
		}

//		System.out.println("NUM : " + agentMemory_.size());
		for ( int i = 0; i < agentMemory_.size(); i++ ){
			ArrayList<Integer> agents = agentMemory_.get(i);
			ArrayList<Role>    roles  = roleMemory_.get(i);
			Set<Agent>         keys   = gameInfo.getRoleMap().keySet();
			boolean matchAll = true;
			for ( int j = 0; j < agents.size(); j++ ){
				for ( Agent key : keys ){
					if ( key.getAgentIdx() == agents.get(j) ){
						Role role = gameInfo.getRoleMap().get(key);
						if ( role.equals(Role.WEREWOLF) ){
							if ( !roles.get(j).equals(Role.WEREWOLF) ){
								matchAll = false;
								break;
							}
						}else if ( role.equals(Role.POSSESSED) ){
							if ( !roles.get(j).equals(Role.POSSESSED) ){
								matchAll = false;
								break;
							}
						}else{
							if ( roles.get(j).equals(Role.WEREWOLF) || roles.get(j).equals(Role.POSSESSED) ){
								matchAll = false;
								break;
							}
						}
					}
				}
			}
			if ( matchAll ){
				missList[infoMemory_.get(i)] *= Math.pow(3.0, 0.01);
//				n++;
			}else{
				missList[infoMemory_.get(i)] *= Math.pow(0.5, 0.001);
//				m++;
			}
		}

		//System.out.println("match : " + n + " , notMatch : " + m);
//		System.out.print("FINISH : ");
		for ( int i = 0; i < missList.length; i++ ){
			double newRate = getRate(i) * missList[i];
			newRate = Math.min(newRate, 2.0);
			newRate = Math.max(newRate, 0.0001);
			setRate(newRate, i);
//			System.out.print(String.format("%.6f", getRate(i)) + " , ");
		}
//		System.out.println();
		agentMemory_.clear();
		roleMemory_.clear();
		infoMemory_.clear();
	}
}







