package com.gmail.sg06.greenrevolution.jingai_table;

import java.util.ArrayList;
import java.util.HashMap;

import org.aiwolf.common.data.Role;
/**
 * AbstractJingaiTableのテスト．abstractメソッド以外のメソッドの動作確認をする
 * @author Yamamoto
 *
 */

public class TestJingaiTable{


	public static void main(String[] args) {
		// TODO 自動生成されたメソッド・スタブ
		//コンストラクタのテスト
		DefaultJingaiTable tjt = new DefaultJingaiTable();

		System.out.println("tjt make end");
		int table[][] = tjt.getTable();

		String txt = "{";
		for(int i = 0; i < table.length; i++){
			txt += "{";
			for(int j = 0; j < table[i].length; j++){
				txt += table[i][j] + ", ";
			}
			txt += "}\n";
		}
		System.out.println(txt);

		//倍率の配列の更新，ゲッターのテスト
		txt = "";
		double r[] = tjt.getRates();
		for(int i = 0; i < r.length; i++){
			txt += r[i] + ", ";
		}

		System.out.println(txt);

		double newR[] = {0.1, 0.2, 0.3, 0.4, 0.5, 0.6, 0.7, 0.8, 0.9, 0.01, 0.02, 0.03, 0.04, 0.05, 0.006};

		tjt.setRates(newR);



		txt = "";
		r = tjt.getRates();
		for(int i = 0; i < r.length; i++){
			txt += r[i] + ", ";
		}

		System.out.println(txt);


		tjt.setRate(5, 0.005);

		txt = "";
		r = tjt.getRates();
		for(int i = 0; i < r.length; i++){
			txt += r[i] + ", ";
		}

		System.out.println(txt);


		//mapの更新，JingaiTableIndex, getWolfRateのテスト
		HashMap<Integer, Double> map = tjt.getTablemap();
		System.out.println(map.size());

		for(Integer i : map.keySet()){
			System.out.print("<" + i + ", " + map.get(i) + ">\n");
		}

		ArrayList<Integer> list = tjt.tableIndexList(5, Role.POSSESSED);
		for(int i = 0; i < list.size(); i++){
			map.put(list.get(i), 0.1);
			txt = "{";
			for(int j = 0; j < 15; j++){
				txt += table[list.get(i)][j] + ",  ";
			}
			txt += "}";
			System.out.println(txt + ": " + map.get(list.get(i)));
		}
		System.out.println(tjt.getWolfRate(4) + " " + tjt.getWolfRate(5));

		list = tjt.tableIndexList(1,Role.WEREWOLF, 5, Role.POSSESSED);
		for(int i = 0; i < list.size(); i++){
			map.put(list.get(i), 0.1);
			txt = "{";
			for(int j = 0; j < 15; j++){
				txt += table[list.get(i)][j] + ",  ";
			}
			txt += "}";
			System.out.println(txt + ": " + map.get(list.get(i)));
		}


		tjt.initTable(true);
		ArrayList<Integer> seerList = new ArrayList<Integer>();
		seerList.add(1);
		seerList.add(3);
		seerList.add(5);

		ArrayList<Integer> mediumList = new ArrayList<Integer>();
		mediumList.add(2);
		mediumList.add(4);

		ArrayList<Integer> BGList = new ArrayList<Integer>();
		BGList.add(13);
		BGList.add(14);

		tjt.calcAttackInfo(8);
		tjt.calcDivineInfo(3, 6, true);
		tjt.calcDivineInfo(1, 7, false);
		tjt.calcInquestInfo(2, 6, true);
		tjt.calcSeerCOInfo(seerList);
		tjt.calcMediumCOInfo(mediumList);
		tjt.calcBGCOInfo(BGList);
		tjt.calcVoteInfo(1, 4);
		tjt.calcVoteInfo(2, 4);
		tjt.calcVoteInfo(3, 4);
		tjt.calcVoteInfo(5, 4);
		tjt.calcVoteInfo(6, 4);
		tjt.calcVoteInfo(7, 4);
		tjt.calcVoteInfo(8, 4);


		double[][] rates  = tjt.getRateTable();
		int[][]    tables = tjt.getTable();
		for ( int i = 0; i < rates.length; i++ ){
			String str = "{";
			for ( int j = 0; j < tables[i].length; j++ ){
				str += tables[i][j] + ",";
			}
			str += "} : ";
			for ( int j = 0; j < rates[i].length; j++ ){
				str += rates[i][j] + "  ";
			}
			System.out.println(i + " : " + str);
		}

		tjt.update();
		for ( int i = 1; i < 16; i++ ){
			System.out.println(i + ":" + tjt.getWolfRate(i) + " and " + tjt.getNotWolfRate(i));
		}
	}

}


