package com.gmail.sg06.greenrevolution.player;

import java.util.ArrayList;
import java.util.LinkedHashMap;
import java.util.TreeMap;

import org.aiwolf.common.data.Agent;
import org.aiwolf.common.net.GameInfo;
import org.aiwolf.common.net.GameSetting;

import com.gmail.sg06.greenrevolution.data.COData;

public class BaseBodyguard extends BaseRole {

	private ArrayList<Integer> guardList_;

	@Override
	public void initialize(GameInfo gameInfo, GameSetting gameSetting) {
		super.initialize(gameInfo, gameSetting);
	}

	@Override
	public void dayStart() {
		super.dayStart();
	}

	@Override
	public String talk() {
		return super.talk();
	}

	@Override
	public Agent vote() {
		return super.vote();
	}

	/**
	 * 護衛
	 * 占＋霊が二人以上で最も村人らしい者を護衛
	 * 占＋霊が一人で偽でなければ護衛
	 * それ以外は最も村らしい者を護衛
	 */
	@Override
	public Agent guard() {
		getData().update(getLatestDayGameInfo());
		guardList_ = new ArrayList<Integer>();
		guardList_.addAll(getData().getTodaySeerCOAgentList());
		guardList_.addAll(getData().getCurrentMediumCOAgentList());

		ArrayList<Integer> fakeList_ = new ArrayList<Integer>();

		LinkedHashMap<Integer, COData> seer_map = getData().getSeerCODataMap();
		COData result;
		for( Integer i: seer_map.keySet() ){
			result = seer_map.get(i);
			if (result.getBlackList().contains( getMe()) )
				fakeList_.add(i);
		}

		guardList_.removeAll(fakeList_);

		if( guardList_.size() > 0 )
			return getMaxLikelyVillAgent(guardList_);

		return getMaxLikelyVillAgent();
	}


	/**
	 * 指定したエージェント(インデックス)の、与えられたListの中での順位を返す
	 */
	public Integer LikelyRank(Integer idx, ArrayList<Double> rateList){
		TreeMap<Double, Integer> map = new TreeMap<Double, Integer>();
		ArrayList<Integer> idxList = getData().getAliveAgentList();
		Integer rank = null;
		for( int i = 0; i < idxList.size(); i++ ){
			map.put(rateList.get(i),idxList.get(i));
		}

		Integer[] sortedIdx = map.values().toArray(new Integer[0]);
		for( int i = 0; i < sortedIdx.length; i++ ){
			if( sortedIdx[i] == idx ){
				rank = sortedIdx.length-i;
				break;
			}
		}		return rank;
	}
}
