package com.gmail.sg06.greenrevolution.player;

import java.util.ArrayList;
import java.util.List;

import org.aiwolf.client.base.player.AbstractRole;
import org.aiwolf.client.lib.TemplateTalkFactory;
import org.aiwolf.common.data.Agent;
import org.aiwolf.common.net.GameInfo;
import org.aiwolf.common.net.GameSetting;

import com.gmail.sg06.greenrevolution.data.MyData;

public class BaseRole extends AbstractRole {

	private MyData data_;
	private List<Agent> agentList_;

	public BaseRole(){
		data_ = new MyData();
	}

	public void initialize(GameInfo gameInfo, GameSetting gameSetting) {
		super.initialize(gameInfo, gameSetting);
		data_.init();
		setAgentList(gameInfo.getAgentList());

	}

	@Override
	public void dayStart() {
		if (getDay() == 0) {
			data_.gameStart(getLatestDayGameInfo());
		}
		if (getDay() > 0) {
			data_.dayStart(getLatestDayGameInfo());
			data_.tableUpdate(0);
		}
	}

	@Override
	public void finish() {
//		System.out.print("finish()");
		data_.learningTableRate(getLatestDayGameInfo());
	}

	@Override
	public String talk() {
		data_.update(getLatestDayGameInfo());
		if ( data_.isOneTimeCall() ){
			data_.tableUpdate(1);
		}

		if ( !data_.isCall() ){
			Agent agent = getMaxLikelyWolfAgent();
			if (agent != null) {
				return TemplateTalkFactory.vote(agent);
			} else {
				return TemplateTalkFactory.skip();
			}
		}
		return TemplateTalkFactory.skip();
	}

	@Override
	public Agent vote() {
		data_.update(getLatestDayGameInfo());
		if ( data_.isOneTimeCall() ){
			data_.tableUpdate(1);
		}
		return getMaxLikelyWolfAgent();
	}

	public MyData getData() {
		return data_;
	}

	public void setData(MyData data) {
		data_ = data;
	}

	protected Agent getMaxLikelyWolfAgent() {
		int voteAgent_ = -1;
		// MyDataから最も狼らしいエージェントを取ってくる．
		voteAgent_ = data_.getMaxLikelyWolf();
		// System.out.println("Max likely wolf-a:" + voteAgent_);

		if (getAgentList().size() >= voteAgent_ && voteAgent_ > -1) {
			return getLatestDayGameInfo().getAgentList().get(voteAgent_ - 1);
		} else {
			System.err
					.println("Error in MaxLikelyWolf of CashBase: agent index is not allowed:"
							+ voteAgent_);
			return null;
		}
	}

	protected Agent getMinLikelyWolfAgent() {
		int voteAgent_ = -1;
		// MyDataから最も狼らしくないエージェントを取ってくる．
		voteAgent_ = data_.getMinLikelyWolf();
		// System.out.println("Max likely wolf-a:" + voteAgent_);

		if (getAgentList().size() >= voteAgent_ && voteAgent_ > -1) {
			return getLatestDayGameInfo().getAgentList().get(voteAgent_ - 1);
		} else {
			System.err
					.println("Error in MinLikelyWolf of CashBase: agent index is not allowed:"
							+ voteAgent_);
			return null;
		}
	}

	protected Agent getMaxLikelyWolfAgent(ArrayList<Integer> list) {
		int voteAgent_ = -1;
		// MyDataから最も狼らしいエージェントを取ってくる．
		voteAgent_ = data_.getMaxLikelyWolf(list);

		// System.out.println("Max likely wolf-b:" + voteAgent_);
		if (getAgentList().size() >= voteAgent_ && voteAgent_ > -1) {
			// return getGameInfo(getDay()).getAgentList().get(voteAgent_-1);
			return getLatestDayGameInfo().getAgentList().get(voteAgent_ - 1);
		} else {
			System.err
					.println("Error in MaxLikelyWolf2 of CashBase: agent index is not allowed:"
							+ voteAgent_ + getMyRole());
			return null;
		}
	}

	protected Agent getMinLikelyWolfAgent(ArrayList<Integer> list) {
		int voteAgent_ = -1;
		// MyDataから最も狼らしくないエージェントを取ってくる．
		voteAgent_ = data_.getMinLikelyWolf(list);
		// System.out.println("Max likely wolf-a:" + voteAgent_);

		if (getAgentList().size() >= voteAgent_ && voteAgent_ > -1) {
			return getLatestDayGameInfo().getAgentList().get(voteAgent_ - 1);
		} else {
			System.err
					.println("Error in MinLikelyWolf of CashBase: agent index is not allowed:"
							+ voteAgent_);
			return null;
		}
	}

	protected Agent getMaxLikelyVillAgent() {
		int voteAgent_ = -1;
		// MyDataから最も村人らしいエージェントを取ってくる．
		voteAgent_ = data_.getMaxLikelyVill();

		// System.out.println("Max likely vill-a:" + voteAgent_);
		if (getAgentList().size() >= voteAgent_ && voteAgent_ > -1) {
			return getLatestDayGameInfo().getAgentList().get(voteAgent_ - 1);
		} else {
			System.err
					.println("Error in MaxLikelyVill of CashBase: agent index is not allowed:"
							+ voteAgent_);
			return null;
		}
	}

	protected Agent getMinLikelyVillAgent() {
		int voteAgent_ = -1;
		// MyDataから最も村人らしくないエージェントを取ってくる．
		voteAgent_ = data_.getMinLikelyVill();

		// System.out.println("Max likely vill-a:" + voteAgent_);
		if (getAgentList().size() >= voteAgent_ && voteAgent_ > -1) {
			return getLatestDayGameInfo().getAgentList().get(voteAgent_ - 1);
		} else {
			System.err
					.println("Error in MinLikelyVill of CashBase: agent index is not allowed:"
							+ voteAgent_);
			return null;
		}
	}

	protected Agent getMaxLikelyVillAgent(ArrayList<Integer> list) {
		int voteAgent_ = -1;
		// MyDataから最も村人らしいエージェントを取ってくる．
		voteAgent_ = data_.getMaxLikelyVill(list);

		// System.out.println("Max likely vill-b:" + voteAgent_);
		if (getAgentList().size() >= voteAgent_ && voteAgent_ > -1) {
			return getLatestDayGameInfo().getAgentList().get(voteAgent_ - 1);
		} else {
			System.err
					.println("Error in MaxLikelyVill2 of CashBase: agent index is not allowed:"
							+ voteAgent_);
			return null;
		}
	}

	protected Agent getMinLikelyVillAgent(ArrayList<Integer> list) {
		int voteAgent_ = -1;
		// MyDataから最も村人らしくないエージェントを取ってくる．
		voteAgent_ = data_.getMinLikelyVill(list);

		// System.out.println("Max likely vill-a:" + voteAgent_);
		if (getAgentList().size() >= voteAgent_ && voteAgent_ > -1) {
			return getLatestDayGameInfo().getAgentList().get(voteAgent_ - 1);
		} else {
			System.err
					.println("Error in MinLikelyVill of CashBase: agent index is not allowed:"
							+ voteAgent_);
			return null;
		}
	}

	@Override
	public String whisper() {
		data_.update(getLatestDayGameInfo());
		return null;
	}

	@Override
	public Agent attack() {
		data_.update(getLatestDayGameInfo());
		return null;
	}

	@Override
	public Agent divine() {
		data_.update(getLatestDayGameInfo());
		return null;
	}

	@Override
	public Agent guard() {
		data_.update(getLatestDayGameInfo());
		return null;
	}

	public List<Agent> getAgentList() {
		return agentList_;
	}

	public void setAgentList(List<Agent> agentList) {
		agentList_ = agentList;
	}

}
