package com.gmail.sg06.greenrevolution.player;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.TreeMap;

import org.aiwolf.client.lib.TemplateTalkFactory;
import org.aiwolf.client.lib.TemplateWhisperFactory;
import org.aiwolf.common.data.Agent;
import org.aiwolf.common.data.Role;
import org.aiwolf.common.net.GameInfo;
import org.aiwolf.common.net.GameSetting;

import com.gmail.sg06.greenrevolution.data.MyData;


public class BaseWerewolf extends BaseRole {

	private Agent willvote_;
	private Agent willattack_;
	private Agent wolf_;
	private ArrayList<Integer> wolfIdx_;
	private ArrayList<Integer> villIdx_;
	private MyData data_ = new MyData();

	@Override
	public void initialize(GameInfo gameInfo, GameSetting gameSetting) {
		super.initialize(gameInfo, gameSetting);
		data_ = getData();
//		Map<Agent, Role> wolfMap = getLatestDayGameInfo().getRoleMap();
		wolfIdx_ = new ArrayList<Integer>();
		villIdx_ = new ArrayList<Integer>();
//		Map<Agent, Role> wolfMap = new HashMap<Agent, Role>();
		Map<Agent, Role> wolfMap = gameInfo.getRoleMap();
		for (Map.Entry<Agent, Role> set : wolfMap.entrySet()) {
			if (set.getValue() == Role.WEREWOLF) {
				wolf_ = (Agent)set.getKey();
				wolfIdx_.add(wolf_.getAgentIdx());
			}
		}
	}

	@Override
	public void dayStart() {
		super.dayStart();
	}

	/**
	 * 1日目以降、狼の狼度を1/2した後で最も狼度の高い者に投票宣言
	 */
	@Override
	public String talk() {
		ArrayList<Double> rateList = data_.getLikelyWolfRate();
		ArrayList<Integer> idxList = data_.getAliveAgentList();

		for( int i = 0; i < idxList.size(); i++ )
			if( wolfIdx_.contains(idxList.get(i)))
				rateList.set(i, rateList.get(i)/2);
		willvote_ = Agent.getAgent(UpdateMaxLikelyWolf(rateList));

		if( willvote_ != null)
			return TemplateTalkFactory.vote(willvote_);

		return super.talk();
	}

	@Override
	public Agent vote() {
		if(willvote_ != null){
			return willvote_;
		}
		return super.vote();
	}

	@Override
	public Agent attack() {
		if(willattack_ != null){
			return willattack_;
		}
		return getMaxLikelyVillAgent();
	}


	/**
	 * 生存者から狼を抜いて最も村らしい者を襲撃対象とする
	 */
	@Override
	public String whisper() {
//		System.out.println(getDay() + "日目");
		List<Agent> vill = new ArrayList<Agent>();
		villIdx_.clear();
		if ( getDay() > 0 ){
			getData().update(getLatestDayGameInfo());
			vill = getLatestDayGameInfo().getAliveAgentList();
		}else{
			vill = this.getGameInfo(0).getAliveAgentList();
		}

		for(Agent ag:vill){
			villIdx_.add(ag.getAgentIdx());
		}

		villIdx_.removeAll(wolfIdx_);
//		villIdx_.remove(wolfIdx_);
//		System.out.println(villIdx_.size());
//		target = getMaxLikelyVillAgent(villIdx_);
//		willattack_ = target;
		willattack_ = getMaxLikelyVillAgent(villIdx_);
		return TemplateWhisperFactory.attack(willattack_);
	}


	/**
	 * 最も狼らしいエージェントインデックスを返す(狼の狼度更新後)
	 */
	public Integer UpdateMaxLikelyWolf( ArrayList<Double> rateList ){
		TreeMap<Double, Integer> map = new TreeMap<Double, Integer>();
		ArrayList<Integer> idxList = data_.getAliveAgentList();

		for( int i = 0; i < idxList.size(); i++ )
			map.put(rateList.get(i),idxList.get(i));

		Integer[] sortedIdx = map.values().toArray(new Integer[0]);

		return sortedIdx[sortedIdx.length-1];
	}

}
