package com.gmail.sg06.greenrevolution.player;

import java.util.ArrayList;
import java.util.LinkedHashMap;

import org.aiwolf.client.lib.TemplateTalkFactory;
import org.aiwolf.common.data.Agent;
import org.aiwolf.common.data.Role;
import org.aiwolf.common.net.GameInfo;
import org.aiwolf.common.net.GameSetting;

import com.gmail.sg06.greenrevolution.data.COData;

public class FakeSearch2 extends BaseRole2 {

	private ArrayList<Integer> aliveFakeList_;// 生きてる中での偽確リスト

	private ArrayList<Integer> fakeList_;// 生死問わない偽確リスト

	private Agent myVoteTarget;

	private Integer turn = 0;
	private boolean isBGCO;

	public void initialize(GameInfo gameInfo, GameSetting gameSetting) {
		super.initialize(gameInfo, gameSetting);
		setAgentList(gameInfo.getAgentList());
//		setData(new MyData());
		aliveFakeList_ = new ArrayList<Integer>();
		fakeList_ = new ArrayList<Integer>();
		isBGCO = false;

	}

	@Override
	public void dayStart() {
		super.dayStart();
		if (getDay() > 0) {
			myVoteTarget = null;
			ArrayList<Integer> attackedList = this.getData()
					.getAttackedAgentList();
			ArrayList<Integer> executedList = this.getData()
					.getExecutedAgentList();
			for (Integer i : attackedList) {
				if (getAliveFakeList().contains(i)) {
					getAliveFakeList().remove(Integer.valueOf(i));
				}
			}
			for (Integer i : executedList) {
				if (getAliveFakeList().contains(i)) {
					getAliveFakeList().remove(Integer.valueOf(i));
				}
			}
		}
	}

	@Override
	public void finish() {
		super.finish();
		// TODO 自動生成されたメソッド・スタブ
	}

	@Override
	public String talk() {
		getData().update(getLatestDayGameInfo());
		if ( getData().isOneTimeCall() ){
			getData().tableUpdate(1);
		}

		turn++;
		//3ターン目以降、吊られそうであれば狩人CO
		if(turn > 2 && !isBGCO){
			Integer executeIdx = getData().getMaxLikelyExecuteAgent();
			Integer me = getMe().getAgentIdx();
			if( executeIdx == me){
				isBGCO = true;
				return TemplateTalkFactory.comingout(getMe(),Role.BODYGUARD);
			}
		}

		aliveFakeSearch();
		fakeSearch();

//		getData().tableUpdate(1);
		if (getAliveFakeList().size() > 0) {
			myVoteTarget = getMaxLikelyWolfAgent(getAliveFakeList());
		}
		if (myVoteTarget == null)
			myVoteTarget = getMaxLikelyWolfAgent();
		return TemplateTalkFactory.vote(myVoteTarget);

	}

	@Override
	public Agent vote() {
		getData().update(getLatestDayGameInfo());
		if ( getData().isOneTimeCall() ){
			getData().tableUpdate(1);
		}
		aliveFakeSearch();
		fakeSearch();
		if (getAliveFakeList().size() > 0) {
			myVoteTarget = getMaxLikelyWolfAgent(getAliveFakeList());
		} else {
			myVoteTarget = getMaxLikelyWolfAgent();
		}
		return myVoteTarget;
	}


	/**
	 * 生きてる中での偽確探し
	 */
	public void aliveFakeSearch() {
		getAliveFakeList().clear();

		// 生存者リスト
		ArrayList<Integer> aliveAgentList = getData().getAliveAgentList();

		LinkedHashMap<Integer, COData> seerCODataMap_ = new LinkedHashMap<Integer, COData>();
		if (getData().getSeerCODataMap().size() > 0) {
			seerCODataMap_ = getData().getSeerCODataMap(); // 占COしたエージェントの情報
		}

		LinkedHashMap<Integer, COData> mediumCODataMap_ = new LinkedHashMap<Integer, COData>();
		mediumCODataMap_ = getData().getMediumCODataMap(); // 霊COしたエージェントの情報


		// 占い師について
		for (java.util.Map.Entry<Integer, COData> entry1 : seerCODataMap_.entrySet()) {
			if ( aliveAgentList.contains(entry1.getKey()) //生きててまだ入ってないなら
					&& !getAliveFakeList().contains(entry1.getKey())){

				if (
						entry1.getValue().getBlackList().size() > 3//４人以上黒出しした占い師

						|| (getMyRole() != Role.WEREWOLF//自分が狼で無いのに自分を黒出しした占い師
								&& entry1.getValue().getBlackList().contains(getMe()))

						|| (getMyRole() == Role.WEREWOLF//自分が狼なのに自分を白出しした占い師
								&& entry1.getValue().getWhiteList().contains(getMe()))

						|| entry1.getValue().getResult(0) != null// 0日目に結果を言っている占い

						) {

					getAliveFakeList().add(entry1.getKey());

				}


				for (Integer black : entry1.getValue().getBlackList()) {//同じ人に違う結果出しした占い師，
					if (entry1.getValue().getWhiteList().contains(black)) {
						getAliveFakeList().add(entry1.getKey());
						break;
					}
				}

			}
		}


		//霊媒師について
		for (java.util.Map.Entry<Integer, COData> entry1 : mediumCODataMap_.entrySet()) {
			if ( aliveAgentList.contains(entry1.getKey()) //生きててまだ入ってないなら
					&& !getAliveFakeList().contains(entry1.getKey())){
				if (
						entry1.getValue().getBlackList().size() > 3// ４人以上黒出しした霊能師

						|| (entry1.getValue().getResult(0) != null// 0,1日目に結果を言っている霊能
								|| entry1.getValue().getResult(1) != null)

						) {

					getAliveFakeList().add(entry1.getKey());
				}

				for (Integer black : entry1.getValue().getBlackList()) {
					if (
							(entry1.getValue().getWhiteList().contains(black)//同じ人に違う結果出しした霊能
									&& !getAliveFakeList().contains(entry1.getKey()))

							|| aliveAgentList.contains(black)//生きている人を黒出しした霊能
							) {
						getAliveFakeList().add(entry1.getKey());
					}
				}

				for (Integer white : entry1.getValue().getWhiteList()) {
					if(aliveAgentList.contains(white)){//生きている人を白出しした霊能
						getAliveFakeList().add(entry1.getKey());
					}
				}

			}


		}




//		System.out.println("size:" + fakeList_.size());

//		ArrayList<Integer> attackedList = this.getData().getAttackedAgentList();
//		ArrayList<Integer> executedList = this.getData().getExecutedAgentList();
//		for (Integer i : attackedList) {
//			if (fakeList_.contains(i)) {
//				fakeList_.remove(Integer.valueOf(i));
//			}
//		}
//		for (Integer i : executedList) {
//			if (fakeList_.contains(i)) {
//				fakeList_.remove(Integer.valueOf(i));
//			}
//		}
	}



	/**
	 * 生死問わず偽確探し
	 */
	public void fakeSearch() {
		getFakeList().clear();

		// 生存者リスト
		ArrayList<Integer> aliveAgentList = getData().getAliveAgentList();

		LinkedHashMap<Integer, COData> seerCODataMap_ = new LinkedHashMap<Integer, COData>();
		if (getData().getSeerCODataMap().size() > 0) {
			seerCODataMap_ = getData().getSeerCODataMap(); // 占COしたエージェントの情報
		}

		LinkedHashMap<Integer, COData> mediumCODataMap_ = new LinkedHashMap<Integer, COData>();
		mediumCODataMap_ = getData().getMediumCODataMap(); // 霊COしたエージェントの情報


		// 占い師について
		for (java.util.Map.Entry<Integer, COData> entry1 : seerCODataMap_.entrySet()) {
			if (!getFakeList().contains(entry1.getKey())){ //まだ入ってないなら

				if (
						entry1.getValue().getBlackList().size() > 3//４人以上黒出しした占い師

						|| (getMyRole() != Role.WEREWOLF//自分が狼で無いのに自分を黒出しした占い師
								&& entry1.getValue().getBlackList().contains(getMe()))

						|| (getMyRole() == Role.WEREWOLF//自分が狼なのに自分を白出しした占い師
								&& entry1.getValue().getWhiteList().contains(getMe()))

						|| entry1.getValue().getResult(0) != null// 0日目に結果を言っている占い

						) {

					getFakeList().add(entry1.getKey());

				}


				for (Integer black : entry1.getValue().getBlackList()) {//同じ人に違う結果出しした占い師，
					if (entry1.getValue().getWhiteList().contains(black)) {
						getFakeList().add(entry1.getKey());
						break;
					}
				}

			}
		}


		//霊媒師について
		for (java.util.Map.Entry<Integer, COData> entry1 : mediumCODataMap_.entrySet()) {
			if (!getFakeList().contains(entry1.getKey())){ //まだ入ってないなら
				if (
						entry1.getValue().getBlackList().size() > 3// ４人以上黒出しした霊能師

						|| (entry1.getValue().getResult(0) != null// 0,1日目に結果を言っている霊能
								|| entry1.getValue().getResult(1) != null)

						) {

					getFakeList().add(entry1.getKey());
				}

				for (Integer black : entry1.getValue().getBlackList()) {
					if (
							(entry1.getValue().getWhiteList().contains(black)//同じ人に違う結果出しした霊能
									&& !getFakeList().contains(entry1.getKey()))

							|| aliveAgentList.contains(black)//生きている人を黒出しした霊能
							) {
						getFakeList().add(entry1.getKey());
					}
				}

				for (Integer white : entry1.getValue().getWhiteList()) {
					if(aliveAgentList.contains(white)){//生きている人を白出しした霊能
						getFakeList().add(entry1.getKey());
					}
				}

			}
		}
	}
	public ArrayList<Integer> getAliveFakeList() {
		return aliveFakeList_;
	}

	public ArrayList<Integer> getFakeList() {
		return fakeList_;
	}


}
