package com.gmail.sg06.greenrevolution.player;

import java.util.ArrayList;
import java.util.LinkedHashMap;
import java.util.List;

import org.aiwolf.common.data.Agent;
import org.aiwolf.common.net.GameInfo;
import org.aiwolf.common.net.GameSetting;

import com.gmail.sg06.greenrevolution.data.COData;

public class JuN1roBodyguard extends BaseBodyguard{

	private List<Agent> agentList_;
	private ArrayList<Integer> guardList_ = new ArrayList<Integer>();
	private ArrayList<Integer> whiteList_ = new ArrayList<Integer>();
	private ArrayList<Integer> fakeList_ = new ArrayList<Integer>();
	private ArrayList<Integer> candidateList_ = new ArrayList<Integer>();
	private Agent guard_;
	private Agent seer_;
	boolean isGuardSeer, isGJ, isFake, isRealSeer;
	FakeSearch f = new FakeSearch();

	@Override
	public void initialize(GameInfo gameInfo, GameSetting gameSetting) {
		super.initialize(gameInfo, gameSetting);
		f.initialize(gameInfo, gameSetting);
		agentList_ = gameInfo.getAgentList();
//		agentList_.remove(getMe());		// 自身を除く
		isGJ = false;
		isFake = false;
		isRealSeer = false;
	}

	@Override
	public void dayStart() {
		super.dayStart();
		if( getDay() > 1)	{
			if(getData().isAlive(getMe().getAgentIdx())){
				Agent guarded_ = getLatestDayGameInfo().getGuardedAgent();
				Agent attacked_ = getLatestDayGameInfo().getAttackedAgent();
//				System.out.println("Me:" + this.getMe().toString() + this.getMyRole());
//				System.out.println("Guard:" + guard_.toString());
//				System.out.println("Guarded:" + guarded_.toString());
				if ( attacked_ == null && getData().isAlive(guarded_.getAgentIdx()) ){
					guard_ = guarded_;
					isGJ = true;
				}
			}
		}
	}

	@Override
	public String talk() {
//		getData().update(getLatestDayGameInfo());
//		getData().tableUpdate(1);
		return super.talk();
	}

	@Override
	public Agent vote() {
//		getData().update(getLatestDayGameInfo());
//		getData().tableUpdate(1);
		return super.vote();
	}

	/**
	 * 護衛
	 * 1.2日目以降GJのときは同じ護衛を続ける
	 * 2.占から最も村人らしい者を護衛
	 * 3.占死亡時、霊から最も村人らしい者を護衛
	 * 4.霊死亡時、モブから最も村人らしい者を護衛
	 */
	@Override
	public Agent guard() {
		getData().update(getLatestDayGameInfo());
		if ( getData().isOneTimeCall() ){
			getData().tableUpdate(1);
		}

		//GJが出ているか確認
		if( isGJ == true ){
			//生存していれば引き続き護衛
			if( getData().isAlive(guard_.getAgentIdx()) )	{ return guard_; }
			//死亡していればGJをリセット
			else	{ isGJ = false; }
		}

		//占真置後、新たな占いが出たら真置解除
		if( getData().getCurrentSeerCOAgentList().size() > 1 && isRealSeer){
			isRealSeer = false;
		}
		//2日目以降、占い二人以上で偽チェック
		if( getData().getCurrentSeerCOAgentList().size() > 1 && !isRealSeer && getDay() > 1 ){
			f.getFakeList();
			f.fakeSearch();
			BeliefSeer1();
		}

		isGuardSeer = false;
		guardList_ = getData().getCurrentSeerCOAgentList();
//		System.out.println("size = " + guardList_.size());
//		System.out.println(guardList_);
		if( guardList_.size() > 0 ){
			isGuardSeer = true;
			//真占が出ていればそいつを、出ていなければ最も村らしいものを選ぶ
			if(isRealSeer && getData().isAlive(seer_.getAgentIdx()) ){
				guard_ = seer_;
				return guard_;
			}else if(!isRealSeer){
				guard_ = getMaxLikelyVillAgent(guardList_);
				return guard_;
			}
		}else{
			guardList_ = new ArrayList<Integer>();
			guardList_ = getData().getCurrentMediumCOAgentList();
			if( guardList_.size() > 0 ){
				guard_ = getMaxLikelyVillAgent(guardList_);
				return guard_;
			}
		}

		guardList_.clear();
		for ( int i = 1; i < agentList_.size()+1; i++ ){
			guardList_.add(i);
		}
//		System.out.println(guardList_.size());
		guardList_.remove(Integer.valueOf(getMe().getAgentIdx()));
		guard_ = getMaxLikelyVillAgent(guardList_);
		return guard_;

	}


	/**
	 * 真占決め
	 * 占2人のとき偽占発見でもう片方を信仰
	 */
	public void BeliefSeer1(){
		//FakeSearchから客観的矛盾を持つ偽占をfakeList_で取得
		ArrayList<Integer> fake =new ArrayList<Integer>();
		fake = f.getFakeList();

		LinkedHashMap<Integer, COData> seer_map = getData().getSeerCODataMap();
		COData result;
		ArrayList<Integer> seerList = (ArrayList<Integer>) getData().getCurrentSeerCOAgentList().clone();

		seerList.remove(fake);
		seerList.remove(getMe());

		if( seerList.size() == 1 ){
			seer_ = agentList_.get(seerList.get(0)-1);
			result = seer_map.get(seerList.get(0));
			if( result != null && result.getWhiteList() != null){
				whiteList_ = result.getWhiteList();
				candidateList_.remove(whiteList_);
			}
			isRealSeer = true;
		}
	}


}
