package com.gmail.sg06.greenrevolution.player;

import java.util.ArrayList;
import java.util.LinkedHashMap;

import org.aiwolf.client.lib.TemplateTalkFactory;
import org.aiwolf.common.data.Agent;
import org.aiwolf.common.data.Judge;
import org.aiwolf.common.data.Species;
import org.aiwolf.common.net.GameInfo;
import org.aiwolf.common.net.GameSetting;

import com.gmail.sg06.greenrevolution.data.COData;

public class JuN1roMedium extends FakeSearch {

	private boolean isCO_;

	private boolean isResult_;


	private ArrayList<Integer> myFakeList_;//主観的偽確リスト

	private ArrayList<Integer> myBlackList_;//自分が黒出ししたリスト
	private ArrayList<Integer> myWhiteList_;//自分が白出ししたリスト


	Agent agent;//自分


	@Override
	public void initialize(GameInfo gameInfo, GameSetting gameSetting) {
		super.initialize(gameInfo, gameSetting);
		agent = gameInfo.getAgent();
		isCO_ = false;

		myFakeList_ = new ArrayList<Integer>();
		myBlackList_ = new ArrayList<Integer>();
		myWhiteList_ = new ArrayList<Integer>();
	}

	@Override
	public void dayStart() {
		super.dayStart();
		isResult_ = false;
		ArrayList<Integer> attackedList = this.getData().getAttackedAgentList();
		ArrayList<Integer> executedList = this.getData().getExecutedAgentList();
		for(Integer i: attackedList){

			if(myBlackList_.contains(i)){
				myBlackList_.remove(Integer.valueOf(i));
			}
			if(myWhiteList_.contains(i)){
				myWhiteList_.remove(Integer.valueOf(i));
			}
			if(myFakeList_.contains(i)){
				myFakeList_.remove(Integer.valueOf(i));
			}
		}
		for(Integer i: executedList){
			if(myBlackList_.contains(i)){
				myBlackList_.remove(Integer.valueOf(i));
			}
			if(myWhiteList_.contains(i)){
				myWhiteList_.remove(Integer.valueOf(i));
			}
			if(myFakeList_.contains(i)){
				myFakeList_.remove(Integer.valueOf(i));
			}
		}
	}

	@Override
	public String talk() {
		getData().update(getLatestDayGameInfo());
		if ( getData().isOneTimeCall() ){
			getData().tableUpdate(1);
		}
		if(!isCO_){
			isCO_ = true;
			return TemplateTalkFactory.comingout(getMe(), getMyRole());
		}
		if(!isResult_ && getDay() > 1){
			isResult_ = true;
			Judge judge = getLatestDayGameInfo().getMediumResult();
			if(judge.getResult() == Species.HUMAN){
				myWhiteList_.add(judge.getTarget().getAgentIdx());
			}
			else{
				myBlackList_.add(judge.getTarget().getAgentIdx());
			}
			return TemplateTalkFactory.inquested(judge.getTarget(), judge.getResult());
		}

		aliveFakeSearch();
		myFakeSearch();

		if(getAliveFakeList().size()>0){
			Agent target = getMaxLikelyWolfAgent(getAliveFakeList());//客観的に見て偽確がいればそいつ
			return TemplateTalkFactory.vote(target);
		}
		if(myFakeList_.size()>0){
			Agent target = getMaxLikelyWolfAgent(myFakeList_);//自分から見て偽確がいればそいつ
			return TemplateTalkFactory.vote(target);
		}
		return TemplateTalkFactory.vote(getMaxLikelyWolfAgent());


	}

	@Override
	public Agent vote() {
		getData().update(getLatestDayGameInfo());
		if ( getData().isOneTimeCall() ){
			getData().tableUpdate(1);
		}

		aliveFakeSearch();
		myFakeSearch();

		if(getAliveFakeList().size()>0){
			Agent target = getMaxLikelyWolfAgent(getAliveFakeList());//客観的に見て偽確がいればそいつ
			return target;
		}
		if(myFakeList_.size()>0){
//			System.out.println(myFakeList_.size());
			Agent target = getMaxLikelyWolfAgent(myFakeList_);//自分から見て偽確がいればそいつ
			return target;
		}
		return getMaxLikelyWolfAgent();
	}


	public void myFakeSearch(){
		// 占い CO したエージェントの情報
		LinkedHashMap<Integer, COData> seerCODataMap_ = getData().getSeerCODataMap();		// 霊COしたエージェントの情報
		// 生存者リスト
		ArrayList<Integer> aliveAgentList = getData().getAliveAgentList();

		// 自分以外の霊能を偽確とする
		myFakeList_ = getData().getCurrentMediumCOAgentList();
		myFakeList_.remove(Integer.valueOf(agent.getAgentIdx()));//自分以外の霊能

		// 自分と異なる結果を言った占いを偽確とする
		for(java.util.Map.Entry<Integer, COData> entry : seerCODataMap_.entrySet()){//自分の結果と異なる結果を言った霊能
			for(Integer black : entry.getValue().getBlackList()){
				if ( aliveAgentList.contains(black) ){
					if(myWhiteList_.contains(black) && !myFakeList_.contains(entry.getKey())){
						myFakeList_.add(entry.getKey());
					}
				}
			}
			for(Integer white : entry.getValue().getWhiteList()){
				if ( aliveAgentList.contains(white) ){
					if(myBlackList_.contains(white) && !myFakeList_.contains(entry.getKey())){
						myFakeList_.add(entry.getKey());
					}
				}
			}
		}
	}
}
