package com.gmail.sg06.greenrevolution.player;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Random;

import org.aiwolf.client.lib.TemplateTalkFactory;
import org.aiwolf.common.data.Agent;
import org.aiwolf.common.data.Role;
import org.aiwolf.common.data.Species;
import org.aiwolf.common.net.GameInfo;
import org.aiwolf.common.net.GameSetting;

public class JuN1roPossessed3 extends BasePossessed3 {

//BJP

	private int myBlackJudgeCount_;

	private boolean seerOrMedium_;

/**
 * 占い対象のリスト
 */
	private ArrayList<Integer> divineList_;

	private HashMap<Integer, Species> inquestMap_;

	private ArrayList<Agent> myBlackList_;

	private Random r_;

	@Override
	public void initialize(GameInfo gameInfo, GameSetting gameSetting) {

		super.initialize(gameInfo, gameSetting);
		Agent agent = gameInfo.getAgent();
		setDivineList(new ArrayList<Integer>());
		List<Agent> list = gameInfo.getAgentList();
		for(int i = 0; i < list.size(); i++){
			getDivineList().add(i);

		}
		getDivineList().remove(Integer.valueOf(agent.getAgentIdx()));//自分以外
		seerOrMedium_ = false;//falseは占い，trueは霊能
		inquestMap_ = new HashMap<Integer, Species>();
		r_ = new Random();

		setMyBlackList(new ArrayList<Agent>());
	}


	@Override
	public void dayStart() {
		super.dayStart();
		setResult(false);
		ArrayList<Integer> attackedList = this.getData().getAttackedAgentList();
		ArrayList<Integer> executedList = this.getData().getExecutedAgentList();
		for(Integer i: attackedList){
			if(getDivineList().contains(i)) getDivineList().remove(i);
		}
		for(Integer i: executedList){
			if(getDivineList().contains(i)) getDivineList().remove(i);
		}

		if(seerOrMedium_ && getDay() > 2){

			Integer agent = getData().getExecutedAgentList().get(getData().getExecutedAgentList().size()-1);
			Species specy;
			if(r_.nextDouble()>=0.5 || getMyBlackJudgeCount() <= 3){
				specy = Species.HUMAN;
			}
			else{
				specy = Species.WEREWOLF;
				setMyBlackJudgeCount(getMyBlackJudgeCount() + 1);
			}
			inquestMap_.put(agent, specy);
		}
	}


	@Override
	public String talk() {
		getData().update(getLatestDayGameInfo());
		if  (getData().isOneTimeCall() ){
			getData().tableUpdate(1);
		}

		if(getData().getToday() == 1 && !isCO()){
			slideTriger();
		}
		if(!seerOrMedium_){
			for(Integer seer : getData().getSeerCOAgentList()){
				if(getDivineList().contains(seer))getDivineList().remove(seer);
			}
			for(Integer medium : getData().getMediumCOAgentList()){
				if(getDivineList().contains(medium))getDivineList().remove(medium);
			}

			if(!isCO()){
				setCO(true);
				return TemplateTalkFactory.comingout(getMe(), Role.SEER);
			}
			if(!isResult() && getDay() != 0){
				setResult(true);
				if(getMyBlackJudgeCount()<3){
					Agent target = liedivine();
					setMyBlackJudgeCount(getMyBlackJudgeCount() + 1);
					getMyBlackList().add(target);
					return TemplateTalkFactory.divined(target, Species.WEREWOLF);
				}
				else{
					Agent target = getMaxLikelyWolfAgent();
					return TemplateTalkFactory.divined(target, Species.HUMAN);
				}
			}

			if (!getData().isCall()) {
				getData().tableUpdate(1);
				if(getMyBlackList().size()>0){
					Agent agent = getMyBlackList().get(0);
					return TemplateTalkFactory.vote(agent);
				} else {
					return TemplateTalkFactory.skip();
				}
			}
			return TemplateTalkFactory.skip();
		}
		else{
			if(!isCO()){
				setCO(true);
				return TemplateTalkFactory.comingout(getMe(), Role.MEDIUM);
			}
			if(getDay() > 1 && inquestMap_.size() > 0){
				for(Integer i :getData().getExecutedAgentList()){
					return TemplateTalkFactory.inquested(getLatestDayGameInfo().getAgentList().get(i), inquestMap_.get(i));
				}
			}

			if (!getData().isCall()) {
				getData().tableUpdate(1);
				Agent agent = getMinLikelyWolfAgent();
				if (agent != null) {
					return TemplateTalkFactory.vote(agent);
				} else {
					return TemplateTalkFactory.skip();
				}
			}

		}
		return TemplateTalkFactory.skip();

	}

	@Override
	public Agent vote() {
		getData().tableUpdate(1);
		if(getMyBlackList().size()>0){
			Agent agent = getMyBlackList().get(0);
			getMyBlackList().remove(agent);
			return agent;
		}
		return getMinLikelyWolfAgent();
	}

	/**
	 * 嘘の占い対象を返す.まだ自分が占っていない生存者の中で最白
	 */
	public Agent liedivine(){
		getData().update(getLatestDayGameInfo());
		Agent target = getMinLikelyWolfAgent(getDivineList());
		if(target == null){
			target = this.getLatestDayGameInfo().getAliveAgentList().get(r_.nextInt(this.getLatestDayGameInfo().getAliveAgentList().size()));
		}
		getDivineList().remove(Integer.valueOf(target.getAgentIdx()));
		return target;
	}

	public void slideTriger(){
//		getData().update(getLatestDayGameInfo());
		if(getData().getSeerCOAgentList().size()>3){
			seerOrMedium_ = true;
		}
	}


	public int getMyBlackJudgeCount() {
		return myBlackJudgeCount_;
	}


	public void setMyBlackJudgeCount(int myBlackJudgeCount) {
		myBlackJudgeCount_ = myBlackJudgeCount;
	}


	public ArrayList<Integer> getDivineList() {
		return divineList_;
	}


	public void setDivineList(ArrayList<Integer> divineList) {
		divineList_ = divineList;
	}


	public ArrayList<Agent> getMyBlackList() {
		return myBlackList_;
	}


	public void setMyBlackList(ArrayList<Agent> myBlackList) {
		myBlackList_ = myBlackList;
	}
}
