package com.gmail.sg06.greenrevolution.player;

import java.util.ArrayList;
import java.util.LinkedHashMap;
import java.util.List;

import org.aiwolf.client.lib.TemplateTalkFactory;
import org.aiwolf.common.data.Agent;
import org.aiwolf.common.data.Judge;
import org.aiwolf.common.data.Species;
import org.aiwolf.common.net.GameInfo;
import org.aiwolf.common.net.GameSetting;

import com.gmail.sg06.greenrevolution.data.COData;

public class JuN1roSeer2 extends FakeSearch2 {

	boolean isCO_;

	private boolean isResult_;

	private ArrayList<Integer> myFakeList_;//主観的偽確リスト

	private ArrayList<Integer> myBlackList_;//自分が黒出ししたリスト
	private ArrayList<Integer> myWhiteList_;//自分が白出ししたリスト


	Agent agent;//自分

	/**
	 * 占い対象のリスト
	 */
	private ArrayList<Integer> divineList_;



	@Override
	public void initialize(GameInfo gameInfo, GameSetting gameSetting) {
		super.initialize(gameInfo, gameSetting);
		agent = gameInfo.getAgent();
		isCO_ = false;
		divineList_ = new ArrayList<Integer>();//占い対象
		List<Agent> list = gameInfo.getAgentList();
		for(int i = 1; i < list.size()+1; i++){
			divineList_.add(i);

		}
		divineList_.remove(Integer.valueOf(agent.getAgentIdx()));//自分以外


		myFakeList_ = new ArrayList<Integer>();
		myBlackList_ = new ArrayList<Integer>();
		myWhiteList_ = new ArrayList<Integer>();
	}





	@Override
	public void dayStart() {
		super.dayStart();
		isResult_ = false;
		ArrayList<Integer> attackedList = this.getData().getAttackedAgentList();
		ArrayList<Integer> executedList = this.getData().getExecutedAgentList();
		for(Integer i: attackedList){
			if( divineList_.contains(i) ){
				divineList_.remove(Integer.valueOf(i));
			}
			if(myBlackList_.contains(i)){
				myBlackList_.remove(Integer.valueOf(i));
			}
			if(myWhiteList_.contains(i)){
				myWhiteList_.remove(Integer.valueOf(i));
			}
			if(myFakeList_.contains(i)){
				myFakeList_.remove(Integer.valueOf(i));
			}
		}
		for(Integer i: executedList){
			if( divineList_.contains(i) ){
				divineList_.remove(Integer.valueOf(i));
			}
			if(myBlackList_.contains(i)){
				myBlackList_.remove(Integer.valueOf(i));
			}
			if(myWhiteList_.contains(i)){
				myWhiteList_.remove(Integer.valueOf(i));
			}
			if(myFakeList_.contains(i)){
				myFakeList_.remove(Integer.valueOf(i));
			}
		}
	}





	@Override
	public String talk() {
		getData().update(getLatestDayGameInfo());
		if ( getData().isOneTimeCall() ){
			getData().tableUpdate(1);
		}
		if(!isCO_){
			isCO_ = true;
			return TemplateTalkFactory.comingout(getMe(), getMyRole());
		}
		if(!isResult_ && getDay() != 0){
			isResult_ = true;
			Judge judge = getLatestDayGameInfo().getDivineResult();
			if(judge == null) System.out.println("judge is null.");
			if(getData().getAliveAgentList().contains(judge.getTarget())){
				if(judge.getResult() == Species.HUMAN){
					myWhiteList_.add(judge.getTarget().getAgentIdx());
				}
				else{
					myBlackList_.add(judge.getTarget().getAgentIdx());
				}
			}
			return TemplateTalkFactory.divined(judge.getTarget(), judge.getResult());
		}

		aliveFakeSearch();

		myFakeSearch();

		if(myBlackList_.size()>0){
			Agent target = getMaxLikelyWolfAgent(myBlackList_);//占い済みの中に黒がいればそいつ
			return TemplateTalkFactory.vote(target);
		}
		if(getAliveFakeList().size()>0){
			Agent target = getMaxLikelyWolfAgent(getAliveFakeList());//客観的に見て偽確がいればそいつ
			return TemplateTalkFactory.vote(target);
		}
		if(myFakeList_.size()>0){
			Agent target = getMaxLikelyWolfAgent(myFakeList_);//自分から見て偽確がいればそいつ
			return TemplateTalkFactory.vote(target);
		}
		if(divineList_.size()>0){
			Agent target = getMaxLikelyWolfAgent(divineList_);//いなければまだ占っていない人から
			return TemplateTalkFactory.vote(target);
		}
		return TemplateTalkFactory.vote(getMaxLikelyWolfAgent());
	}





/**
 * 投票先は現在生き残っていて，吊られそうでなく, 自分がまだ占っていないエージェント
 */
	@Override
	public Agent divine() {
		getData().update(getLatestDayGameInfo());
		if ( getData().isOneTimeCall() ){
			getData().tableUpdate(1);
		}
		int executeIdx = getData().getMaxLikelyExecuteAgent();
		Agent execute = getLatestDayGameInfo().getAgentList().get(executeIdx - 1);
		ArrayList<Integer> removedList = new ArrayList<Integer>();
		removedList = (ArrayList<Integer>) divineList_.clone();
		removedList.remove(execute);

//		System.out.print(divineList_.size());
		Agent target = getMaxLikelyWolfAgent(divineList_);
//		System.out.println(target.toString());
//		if(target == null){
//			target = this.getLatestDayGameInfo().getAliveAgentList().get(rnd.nextInt(this.getLatestDayGameInfo().getAliveAgentList().size()));
//		}
		if ( target == null ){
//			System.exit(-1);
			target = getMaxLikelyWolfAgent();
		}

		return target;
	}





	public void myFakeSearch(){
		// 霊能 CO したエージェントの情報
		LinkedHashMap<Integer, COData> mediumCODataMap_ = getData().getMediumCODataMap();		// 霊COしたエージェントの情報
		// 生存者リスト
		ArrayList<Integer> aliveAgentList = getData().getAliveAgentList();

		// 自分以外の占いを偽確とする
		myFakeList_ = getData().getCurrentSeerCOAgentList();
		myFakeList_.remove(Integer.valueOf(agent.getAgentIdx()));

		// 自分の結果と異なる結果を言った霊能を偽確とする
		for(java.util.Map.Entry<Integer, COData> entry : mediumCODataMap_.entrySet()){//自分の結果と異なる結果を言った霊能
			for(Integer black : entry.getValue().getBlackList()){
				if ( aliveAgentList.contains(black) ){
					if( myWhiteList_.contains(black) && !myFakeList_.contains(entry.getKey()) ){
						myFakeList_.add(entry.getKey());
					}
				}
			}
			for(Integer white : entry.getValue().getWhiteList()){
				if ( aliveAgentList.contains(white) ){
					if(myBlackList_.contains(white) && !myFakeList_.contains(entry.getKey())){
						myFakeList_.add(entry.getKey());
					}
				}
			}
		}
		ArrayList<Integer> attackedList = this.getData().getAttackedAgentList();
		ArrayList<Integer> executedList = this.getData().getExecutedAgentList();
		for(Integer i: attackedList){
			if(myFakeList_.contains(i)){
				myFakeList_.remove(Integer.valueOf(i));
			}
		}
		for(Integer i: executedList){
			if(myFakeList_.contains(i)){
				myFakeList_.remove(Integer.valueOf(i));
			}
		}

	}

	@Override
	public Agent vote(){

		getData().update(getLatestDayGameInfo());
		if ( getData().isOneTimeCall() ){
			getData().tableUpdate(1);
		}

		aliveFakeSearch();

		myFakeSearch();

		if(myBlackList_.size()>0){
			Agent target = getMaxLikelyWolfAgent(myBlackList_);//占い済みの中に黒がいればそいつ
			return target;
		}
		if(getAliveFakeList().size()>0){
			Agent target = getMaxLikelyWolfAgent(getAliveFakeList());//客観的に見て偽確がいればそいつ
			return target;
		}
		if(myFakeList_.size()>0){
			Agent target = getMaxLikelyWolfAgent(myFakeList_);//自分から見て偽確がいればそいつ
			return target;
		}
		if(divineList_.size()>0){
			Agent target = getMaxLikelyWolfAgent(divineList_);//いなければまだ占っていない人から
			return target;
		}
		return getMaxLikelyWolfAgent();
	}

	public ArrayList<Integer> getDivineList(){
		return divineList_;
	}

}
