package com.gmail.sg06.greenrevolution.player;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Random;

import org.aiwolf.client.lib.TemplateTalkFactory;
import org.aiwolf.common.data.Agent;
import org.aiwolf.common.data.Role;
import org.aiwolf.common.net.GameInfo;
import org.aiwolf.common.net.GameSetting;

import com.gmail.sg06.greenrevolution.data.COData;

public class JuN1roVillager extends FakeSearch{

	private List<Agent> agentList_;
	private ArrayList<Integer> candidate_;
	private ArrayList<Integer> white_;
	private Agent Seer;
	boolean isCO, isRealSeer;
	private String willtalk;
	public Integer turn;
	public Random rnd;


	public void initialize(GameInfo gameInfo, GameSetting gameSetting) {
		super.initialize(gameInfo, gameSetting);
		agentList_ = gameInfo.getAgentList();
		isCO = false;
		isRealSeer = false;
		rnd = new Random();
	}


	@Override
	public void dayStart() {
		super.dayStart();
		turn = 0;
	}

	@Override
	public String talk() {
		getData().update(getLatestDayGameInfo());
		if  (getData().isOneTimeCall() ){
			getData().tableUpdate(1);
		}
		candidate_ = getData().getAliveAgentList();
		willtalk = null;
		turn++ ;

		fakeSearch();


		//estimate宣言(寡黙対策)
		if( rnd.nextInt(10) < 3 )	{ EstimateMaxLikely(); }

		//占真置後、新たな占いが出たら真置解除
		if( getData().getCurrentSeerCOAgentList().size() > 1 && isRealSeer){
			isRealSeer = false;
		}
		//2日目以降、偽チェック
		if(!isRealSeer && getDay() > 1 ){
			BeliefSeer1();
		}

		//黒出しされたら狩人CO
		if( isFakeBlack() ){
			willtalk = TemplateTalkFactory.comingout(getMe(),Role.BODYGUARD);
		}

		//初日ランダムで占いCO
		if( getDay() < 2 && turn == 1 ){
			SeerCO(getDay());
		}

		if( willtalk != null ){
			return willtalk;
		}

		return super.talk();
	}



	@Override
	public Agent vote() {
		return super.vote();
	}

	/**
	 * 初日占いCO
	 * 0.1の確率で0日目1ターンで占いCO、1日目1ターンで村スラ
	 */
	public void SeerCO(int day){
		if( day == 0 ){
			Integer r = rnd.nextInt(10);
			if( r < 1 )	{
				isCO = true;
				willtalk = TemplateTalkFactory.comingout(getMe(),Role.SEER);
			}
		}else if( day == 1 && isCO == true ){
				willtalk = TemplateTalkFactory.comingout(getMe(),Role.VILLAGER);
		}
	}

	/**
	 * estimate宣言
	 * 0.3の確率で最白村か最黒狼estimate宣言
	 */
	public void EstimateMaxLikely(){
		Integer r = rnd.nextInt(2);
		if( r == 0 ){
			willtalk = TemplateTalkFactory.estimate(getMaxLikelyVillAgent(), Role.VILLAGER);
		}else{
			willtalk = TemplateTalkFactory.estimate(getMaxLikelyWolfAgent(candidate_), Role.WEREWOLF);
		}
	}

	/**
	 * 真占決め(その1：確定的)
	 * 占2人のとき偽占発見でもう片方を信仰
	 */
	public void BeliefSeer1(){
		ArrayList<Integer> fake =new ArrayList<Integer>();
		fake = getFakeList();

		LinkedHashMap<Integer, COData> seer_map = getData().getSeerCODataMap();
		COData result;
		ArrayList<Integer> seer_ = (ArrayList<Integer>) getData().getCurrentSeerCOAgentList().clone();

		seer_.remove(fake);
		seer_.remove(getMe());

		if( seer_.size() == 1 ){
			Seer = agentList_.get(seer_.get(0)-1);
			result = seer_map.get(seer_.get(0));
			if( result != null && result.getWhiteList() != null){
				white_ = result.getWhiteList();
				candidate_.remove(white_);
			}
			isRealSeer = true;
		}
	}

	/**
	 * 真占決め(その2：予測的)
	 * 占2以上のとき
	 * 村度が最も高い、かつ狼度が最も低ければ信仰
	 */
	public void BeliefSeer2(ArrayList<Integer> seerList) {
		HashMap<Integer, Double> Vmap = getData().getLikelyVillRateMap();
		HashMap<Integer, Double> Wmap = getData().getLikelyWolfRateMap();
		Integer x;
		for( Integer idx1: seerList ){
			x = 1;
			for( Integer idx2: seerList )
				if( Vmap.get(idx1) > Vmap.get(idx2) && Wmap.get(idx1) < Wmap.get(idx2) ){ x++; }
			if( x == seerList.size() ){
				Seer = agentList_.get(idx1-1);
			}
		}
	}

	/**
	 * 自分へのDIVINE RESULT考慮
	 */
	public boolean isFakeBlack(){
		LinkedHashMap<Integer, COData> seerCODataMap_ = new LinkedHashMap<Integer, COData>();
		if (getData().getSeerCODataMap().size() > 0) {
			seerCODataMap_ = getData().getSeerCODataMap(); // 占COしたエージェントの情報
		}
		for (java.util.Map.Entry<Integer, COData> entry1 : seerCODataMap_.entrySet()) {
			if (entry1.getValue().getBlackList().contains(getMe())){
				return true;
			}
		}
		return false;
	}

}
