package com.gmail.sg06.greenrevolution.player;

import java.util.ArrayList;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Random;

import org.aiwolf.client.lib.TemplateWhisperFactory;
import org.aiwolf.common.data.Agent;
import org.aiwolf.common.data.Role;
import org.aiwolf.common.net.GameInfo;
import org.aiwolf.common.net.GameSetting;

import com.gmail.sg06.greenrevolution.data.BGCOData;
import com.gmail.sg06.greenrevolution.data.COData;


public class JuN1roWerewolf  extends FakeSearch{


	private List<Agent> agentList_;
	ArrayList<Integer> wolfIdx_;
	ArrayList<Integer> villIdx_;
	Agent willattack_,attacked_;
	ArrayList<Integer> seer_		= new ArrayList<Integer>();
	ArrayList<Integer> medium_		= new ArrayList<Integer>();
	ArrayList<Integer> bodyguard_	= new ArrayList<Integer>();
	ArrayList<Integer> possessed_;
	boolean isGJ;
	Random rnd = new Random();


	@Override
	public void initialize(GameInfo gameInfo, GameSetting gameSetting) {
		super.initialize(gameInfo, gameSetting);
		wolfIdx_ = new ArrayList<Integer>();
		villIdx_ = new ArrayList<Integer>();
		Map<Agent, Role> wolfMap = gameInfo.getRoleMap();
		for (Map.Entry<Agent, Role> set : wolfMap.entrySet()) {
			if (set.getValue() == Role.WEREWOLF) {
				Agent wolf_ = (Agent)set.getKey();
				wolfIdx_.add(wolf_.getAgentIdx());
			}else{
				Agent vill_ = (Agent)set.getKey();
				villIdx_.add(vill_.getAgentIdx());
			}
		}
		isGJ = false;
		possessed_ = new ArrayList<Integer>();
	}
	@Override
	public void dayStart() {
		super.dayStart();
		attacked_ = willattack_;
		willattack_ = null;
		if ( getDay() > 1 ){
			GJcheck();
		}
	}

	@Override
	public String talk() {
//		getData().update(getLatestDayGameInfo());
//		getData().tableUpdate(1);
//		System.out.println("talk");

		return super.talk();
	}

	@Override
	public Agent vote() {
//		getData().update(getLatestDayGameInfo());
//		getData().tableUpdate(1);

		return super.vote();
	}

	@Override
	public Agent attack() {
		//襲撃予定者が釣られそうでなければ襲撃
		if(willattack_ != null){
			getData().update(getGameInfo(getDay()));
			getData().tableUpdate(1);
			int executeIdx = getData().getMaxLikelyExecuteAgent();
			Agent execute = getLatestDayGameInfo().getAgentList().get(executeIdx - 1);
			if(willattack_ != execute){
				return willattack_;
			}
		}
		return super.attack();
	}

	@Override
	public String whisper() {
		//占狩霊優先噛み(狂人考慮)
		seer_		= getData().getTodaySeerCOAgentList();
		medium_		= getData().getTodayMediumCOAgentList();
		bodyguard_	= getData().getTodayBGCOAgentList();
		String willtalk = null;

		if (!getData().isCall()) {
			getData().update(getGameInfo(getDay()));
			getData().tableUpdate(1);
			//GJが出ていれば騎士噛み
			if(isGJ){
				isGJ = false;
				return TemplateWhisperFactory.attack(willattack_);
			}

			//狂人探し
			judge();

			//占→騎→霊の順で噛み
			willtalk = RoleAttack(seer_);
			if( willtalk == null ){
				willtalk = RoleAttack(bodyguard_);
				if( willtalk == null ){
					willtalk = RoleAttack(medium_);
				}
			}
			if( willtalk != null ){ return willtalk; }

			//役持ちがいなければ村噛み
			willattack_ = getMaxLikelyVillAgent();
			if(willattack_ != null)
				return TemplateWhisperFactory.attack(willattack_);
			else
				return super.whisper();
		}



		return TemplateWhisperFactory.skip();
	}


	/**
	 * 占、霊が狼以外で二人以上のとき
	 * 結果から真狂判定をする
	 */
	public void judge() {
		possessed_.clear();
		seer_ = getData().getTodaySeerCOAgentList();
		medium_ = getData().getTodayMediumCOAgentList();
		seer_.removeAll(wolfIdx_);
		medium_.removeAll(wolfIdx_);
		ArrayList<Integer> black = new ArrayList<Integer>();
		ArrayList<Integer> white = new ArrayList<Integer>();

		if( seer_.size() > 1 || medium_.size() > 1 ){
			LinkedHashMap<Integer, COData> seer_map = getData().getSeerCODataMap();
			LinkedHashMap<Integer, COData> medium_map = getData().getMediumCODataMap();
			COData result;

			for( Integer i: seer_map.keySet() ){
				if( !(wolfIdx_.contains(i)) ){
					result = seer_map.get(i);
					black = result.getBlackList();
					white = result.getWhiteList();
					if( black.contains(villIdx_) || white.contains(wolfIdx_) ){
						possessed_.add(i);
						break;
					}
				}
			}
			for( Integer i: medium_map.keySet() ){
				if( !(wolfIdx_.contains(i)) ){
					result = medium_map.get(i);
					black = result.getBlackList();
				white = result.getWhiteList();
					if(black.contains(villIdx_) || white.contains(wolfIdx_) ){
						possessed_.add(i);
						break;
					}
				}
			}
		}
	}

	/**
	 * 指定した役職(リスト)から狼と狂人を考慮して噛み対象を返す
	 */
	public String RoleAttack(ArrayList<Integer> roleList) {
		roleList.removeAll(wolfIdx_);

		if( roleList.size() > 0 && possessed_.size()>0)
			roleList.removeAll(possessed_);

		if( roleList.size() > 0 ){
			willattack_ = getMaxLikelyVillAgent(roleList);
			return TemplateWhisperFactory.attack(willattack_);
		}

		return null;
	}

	/**
	 * GJ
	 * 狼の襲撃が失敗したとき、
	 * 狩人が言った護衛先が襲撃先だった場合優先して噛む
	 */
	public void GJcheck() {
		ArrayList<Integer> attackedList = new ArrayList<Integer>();
		ArrayList<Integer> guardList = new ArrayList<Integer>();
		attackedList = getData().getAttackedAgentList();
		Integer attackedIdx = attackedList.get( attackedList.size() - 1 );

		if( attackedIdx == -1){
			LinkedHashMap<Integer, BGCOData> bodyguard_map = getData().getBgCODataMap();
			BGCOData result;

			for( Integer i: bodyguard_map.keySet() ){
				if( !(wolfIdx_.contains(i)) || !possessed_ .contains(i)){
					result		= bodyguard_map.get(i);
					guardList	= result.getGuardList();
					if( guardList.contains(attacked_) ){
						willattack_ = agentList_.get(i);
						isGJ = true;
					}
				}
			}
		}
	}

	public ArrayList<Integer> getWolfIdx(){
		return wolfIdx_;
	}
	public ArrayList<Integer> getPossessedIdx(){
		return possessed_;
	}

}
