package com.gmail.sg06.greenrevolution.player;

import java.util.HashMap;
import java.util.Random;

import org.aiwolf.client.lib.TemplateTalkFactory;
import org.aiwolf.common.data.Agent;
import org.aiwolf.common.data.Role;
import org.aiwolf.common.data.Species;
import org.aiwolf.common.net.GameInfo;
import org.aiwolf.common.net.GameSetting;

/**
 * 基本占い語りをして，１日目の１ターン目に占いＣＯ者が４人以上なら霊能ＣＯ
 *
 * @author Yamamoto
 *
 * 霊能ＣＯした場合，霊能結果は自分の黒出しが3人以下なら50%で黒出し．
 */
public class SlideCOPossessed extends JuN1roPossessed {

	private boolean seerOrMedium_;

	/**
	 * ニセ霊能結果のリスト
	 */
	private HashMap<Integer, Species> inquestMap_;

	Random r_;

	public void initialize(GameInfo gameInfo, GameSetting gameSetting) {

		super.initialize(gameInfo, gameSetting);
		seerOrMedium_ = false;//falseは占い，trueは霊能
		inquestMap_ = new HashMap<Integer, Species>();
		r_ = new Random();
	}
	public void dayStart(){
		super.dayStart();
		if(seerOrMedium_ && getDay() > 2){

			Integer agent = getData().getExecutedAgentList().get(getData().getExecutedAgentList().size()-1);
			Species specy;
			if(r_.nextDouble()>=0.5 || getMyBlackJudgeCount() <= 3){
				specy = Species.HUMAN;
			}
			else{
				specy = Species.WEREWOLF;
				setMyBlackJudgeCount(getMyBlackJudgeCount() + 1);
			}
			inquestMap_.put(agent, specy);
		}
	}

	@Override
	public String talk() {
		getData().update(getLatestDayGameInfo());
		if ( getData().isOneTimeCall() ){
			getData().tableUpdate(1);
		}

		if(getData().getToday() == 1 && !isCO()){
			slideTriger();
		}
		if(!seerOrMedium_){
			for(Integer seer : getData().getSeerCOAgentList()){
				if(getDivineList().contains(seer))getDivineList().remove(seer);
			}
			for(Integer medium : getData().getMediumCOAgentList()){
				if(getDivineList().contains(medium))getDivineList().remove(medium);
			}

			if(!isCO()){
				setCO(true);
				return TemplateTalkFactory.comingout(getMe(), Role.SEER);
			}
			if(!isResult() && getDay() != 0){
				setResult(true);
				if(getMyBlackJudgeCount()<3){
					Agent target = liedivine();
					setMyBlackJudgeCount(getMyBlackJudgeCount() + 1);
					getMyBlackList().add(target);
					return TemplateTalkFactory.divined(target, Species.WEREWOLF);
				}
				else{
					Agent target = getMaxLikelyWolfAgent();
					return TemplateTalkFactory.divined(target, Species.HUMAN);
				}
			}

			if (!getData().isCall()) {
				getData().tableUpdate(1);
				if(getMyBlackList().size()>0){
					Agent agent = getMyBlackList().get(0);
					return TemplateTalkFactory.vote(agent);
				} else {
					return TemplateTalkFactory.skip();
				}
			}
			return TemplateTalkFactory.skip();
		}

		else{
			if(!isCO()){
				setCO(true);
				return TemplateTalkFactory.comingout(getMe(), Role.MEDIUM);
			}
			if(getDay() > 1 && inquestMap_.size() > 0){
				for(Integer i :getData().getExecutedAgentList()){
					return TemplateTalkFactory.inquested(getLatestDayGameInfo().getAgentList().get(i), inquestMap_.get(i));
				}
			}

			if (!getData().isCall()) {
				getData().tableUpdate(1);
				Agent agent = getMinLikelyWolfAgent();
				if (agent != null) {
					return TemplateTalkFactory.vote(agent);
				} else {
					return TemplateTalkFactory.skip();
				}
			}

		}
		return TemplateTalkFactory.skip();

	}

	@Override
	public Agent vote() {
		if(!seerOrMedium_){
			getData().tableUpdate(1);
			if(getMyBlackList().size()>0){
				Agent agent = getMyBlackList().get(0);
				getMyBlackList().remove(agent);
				return agent;
			}
		}
		return getMinLikelyWolfAgent();
	}

	public void slideTriger(){
//		getData().update(getLatestDayGameInfo());
		if(getData().getSeerCOAgentList().size()>3){
			seerOrMedium_ = true;
		}
	}
}
