package com.gmail.sg06.greenrevolution.player;

import java.util.ArrayList;
import java.util.HashMap;

import org.aiwolf.client.base.player.AbstractRole;
import org.aiwolf.client.base.player.AbstractRoleAssignPlayer;
import org.aiwolf.common.data.Role;

import com.gmail.sg06.greenrevolution.weightedplayer.WeightedPlayer;

public class WeightedJuN1roPlayer extends AbstractRoleAssignPlayer {

	private HashMap<Role, Integer> sizeMap_;

	@Override
	public String getName() {
		return "Litt1eGirl";
	}

	public WeightedJuN1roPlayer() {
		sizeMap_ = new HashMap<Role, Integer>();
		setVillagerPlayer(new JuN1roVillager());
		setSeerPlayer(getSeer());
		setMediumPlayer(new JuN1roMedium());
		setBodyguardPlayer(new JuN1roBodyguard());
		setPossessedPlayer(getPossessed());
		setWerewolfPlayer(getWerewolf());
	}

	private AbstractRole getSeer() {
		ArrayList<AbstractRole> list = new ArrayList<AbstractRole>();
		// 予選提出の占い師＋吊られそうなプレイヤの占い回避占い師
		AbstractRole JuN1roSeer = new JuN1roSeer();
		list.add(JuN1roSeer);

		AbstractRole JuN1roSeer2 = new JuN1roSeer2();
		list.add(JuN1roSeer2);

		// COを1日目にする
		AbstractRole Day1COSeer = new Day1COSeer();
		list.add(Day1COSeer);

		sizeMap_.put(Role.SEER, list.size());
		WeightedPlayer player = new WeightedPlayer(list, true);
		return player;
	}

	private AbstractRole getWerewolf() {
		ArrayList<AbstractRole> list = new ArrayList<AbstractRole>();
		// 予選提出の狼＋吊られそうなプレイヤの噛み回避狼
		AbstractRole JuN1roWerewolf = new JuN1roWerewolf();
		list.add(JuN1roWerewolf);
		// 霊媒優先噛み狼
		AbstractRole AttackMediumWerewolf = new AttackMediumWerewolf();
		list.add(AttackMediumWerewolf);
		// 役職COの狼
		AbstractRole RoleCOWerewolf = new RoleCOWerewolf();
		list.add(RoleCOWerewolf);
		// 狩人COの狼
		AbstractRole BodyguardCOWerewolf = new BodyguardCOWerewolf();
		list.add(BodyguardCOWerewolf);

		sizeMap_.put(Role.WEREWOLF, list.size());
		WeightedPlayer player = new WeightedPlayer(list, true);
		return player;
	}

	private AbstractRole getPossessed() {
		ArrayList<AbstractRole> list = new ArrayList<AbstractRole>();
		// 予選提出の狂
		AbstractRole JuN1roPossessed = new JuN1roPossessed();
		list.add(JuN1roPossessed);

		AbstractRole rivalBlack = new RivalBlackPossessed();
		list.add(rivalBlack);

		AbstractRole samevote = new SameVotePossessed();
		list.add(samevote);

		sizeMap_.put(Role.POSSESSED, list.size());
		WeightedPlayer player = new WeightedPlayer(list, true);
		return player;
	}

	public HashMap<Role, Integer> getSizeMap() {
		return sizeMap_;
	}

}
