package com.gmail.sg06.greenrevolution.starter;

import java.io.PrintStream;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map;
import java.util.Random;

import org.aiwolf.common.AIWolfAgentException;
import org.aiwolf.common.data.Player;
import org.aiwolf.common.data.Role;
import org.aiwolf.common.data.Team;
import org.aiwolf.common.net.GameSetting;
//import org.aiwolf.kajiClient.LearningPlayer.*;
import org.aiwolf.server.AIWolfGame;
import org.aiwolf.server.net.DirectConnectServer;
import org.aiwolf.server.net.GameServer;

import com.carlo.aiwolf.bayes.player.BayesPlayer;
import com.carlo.aiwolf.sample.player.SamplePlayer;

/**
 * RoleRequestで何回も回す
 * Bayesエージェントの性能テスト用
 * @author carlo
 *
 */

public class TestStarter {

	/**
	 * 参加エージェントの数
	 * 大会は15
	 * 10人で全役職あり
	 * 
	 * 結果ネットワーク生成に使ってる
	 */
	static protected int PLAYER_NUM = 15;


	public static void main(String[] args)  {

		try{


			int gameNum=1;
			if(args.length>0){
				//第一引数：試行回数
				gameNum=Integer.parseInt(args[0]);
			}
			String fileName=gameNum+"_70_m_solo.csv";
			//ファイル出力
			PrintStream out = new PrintStream(fileName);
			//置き換える
			// System.setOut(out);
			// System.out.println("Agent,Role");
			

			//村人側勝利数
			int villagerWinNum = 0;
			//人狼側勝利数
			int werewolfWinNum = 0;


			//対戦相手クラス
			ArrayList<Class> classes=new ArrayList<Class>();
			classes.add(Class.forName("org.aiwolf.client.base.smpl.SampleRoleAssignPlayer"));
			classes.add(Class.forName("com.yy.player.YYRoleAssignPlayer"));
			classes.add(Class.forName("jp.halfmoon.inaba.aiwolf.strategyplayer.StrategyPlayer"));
			//classes.add(Class.forName("org.aiwolf.kajiClient.LearningPlayer.KajiRoleAssignPlayer"));
			classes.add(Class.forName("com.gmail.jinro.noppo.players.RoleAssignPlayer"));
			classes.add(Class.forName("org.aiwolf.Satsuki.LearningPlayer.AIWolfMain"));
			classes.add(Class.forName("jp.ac.shibaura_it.ma15082.WasabiRoleAssignPlayer"));
			classes.add(Class.forName("takata.player.TakataRoleAssignPlayer"));
			classes.add(Class.forName("ipa.myAgent.IPARoleAssignPlayer"));
			classes.add(Class.forName("org.aiwolf.iace10442.ChipRoleAssignPlayer"));
			classes.add(Class.forName("kainoueAgent.MyRoleAssignPlayer"));
			classes.add(Class.forName("com.github.haretaro.pingwo.role.PingwoRoleAssignPlayer"));
			classes.add(Class.forName("com.gmail.the.seventh.layers.RoleAssignPlayer"));
			classes.add(Class.forName("jp.ac.cu.hiroshima.info.cm.nakamura.player.NoriRoleAssignPlayer"));



			for(int i = 0;i<gameNum;i++){
				if(i%1000==0) System.out.println(i+"/"+gameNum);
				Map<Player, Role> playerMap = new HashMap<Player, Role>();

				for(int j=0;j<PLAYER_NUM-1-1;j++){

					//ランダムで追加
					int rnd=new Random().nextInt(classes.size());
					playerMap.put((Player) classes.get(rnd).newInstance(), null);
				}

				Player myPlayer=new BayesPlayer();
				playerMap.put(myPlayer, Role.SEER);
				playerMap.put(new SamplePlayer(), Role.POSSESSED);
				

				GameServer gameServer = new DirectConnectServer(playerMap);
				GameSetting gameSetting = GameSetting.getDefaultGame(PLAYER_NUM);
				AIWolfGame game = new AIWolfGame(gameSetting, gameServer);
				//game.setShowConsoleLog(false);

				game.setRand(new Random(gameSetting.getRandomSeed()));
				
				game.start();

				if(game.getWinner() == Team.VILLAGER){
					villagerWinNum++;
				}else{
					werewolfWinNum++;
				}


			}
			//System.out.println("inaniwa"+" :"+werewolfWinNum+"/"+(werewolfWinNum+villagerWinNum));

		}
		catch(AIWolfAgentException e){
			e.printStackTrace();
		}
		catch(Exception e){
		}
	}
		
}
