package com.gmail.sg06.greenrevolution.starter.competition;


public class CSMain{

	public static void main(String[] args) throws ClassNotFoundException, InstantiationException, IllegalAccessException {
		//ゲーム試行回数
		int gameNum = 200000;
		//ゲームログを保存するか
		boolean isSaveLog=false;
		//ゲームの経過をコンソールで表示するか
		boolean isShowConsoleLog=false;

		// コマンドライン引数で、動作を変えることもできます。
		// 例 -n 100 -l -s	:ゲーム試行回数100回、ゲームログを保存、コンソールログを表示
		// 例　-n 10		:ゲーム試行回数10回、ゲームログを保存しない(デフォルト)、コンソールログを表示しない(デフォルト)
		for (int i = 0; i < args.length; i++) {
			if (args[i].startsWith("-")) {
				if (args[i].equals("-n")) {
					i++;
					gameNum = Integer.parseInt(args[i]);
				}
				else if(args[i].equals("-l")){
					isSaveLog=true;
				}
				else if(args[i].equals("-s")){
					isShowConsoleLog=true;
				}
			}
		}

		CompetitionStarter starter=new CompetitionStarter(gameNum);

		//プレイヤークラスの追加
		//サンプルプレイヤーを1ゲームに３体追加する
		//複数体追加した場合、結果の集計は合算
		starter.addClass(Class.forName("org.aiwolf.client.base.smpl.SampleRoleAssignPlayer"),"サンプル");
		starter.addClass(Class.forName("com.yy.player.YYRoleAssignPlayer"),"YY");
		starter.addClass(Class.forName("com.carlo.aiwolf.bayes.player.BayesPlayer"),"Bayes");
		starter.addClass(Class.forName("jp.halfmoon.inaba.aiwolf.strategyplayer.StrategyPlayer"),"饂飩",1);
		//starter.addClass(Class.forName("org.aiwolf.kajiClient.LearningPlayer.KajiRoleAssignPlayer"));
		//starter.addClass(Class.forName("com.gmail.jinro.noppo.players.RoleAssignPlayer"),"働きの悪");
		starter.addClass(Class.forName("org.aiwolf.Satsuki.LearningPlayer.AIWolfMain"),"Satuki",1);
		starter.addClass(Class.forName("jp.ac.shibaura_it.ma15082.WasabiRoleAssignPlayer"),"Wasabi");
		starter.addClass(Class.forName("takata.player.TakataRoleAssignPlayer"),"GofukuLab");
		starter.addClass(Class.forName("ipa.myAgent.IPARoleAssignPlayer"),"IPA");
		starter.addClass(Class.forName("org.aiwolf.iace10442.ChipRoleAssignPlayer"),"iace10442");
		starter.addClass(Class.forName("kainoueAgent.MyRoleAssignPlayer"),"swingby"); //swingby
		//starter.addClass(Class.forName("jp.ac.aitech.k13009kk.aiwolf.client.player.AndoRoleAssignPlayer"));
		starter.addClass(Class.forName("com.github.haretaro.pingwo.role.PingwoRoleAssignPlayer"),"平兀");
		starter.addClass(Class.forName("com.gmail.the.seventh.layers.RoleAssignPlayer"),"Fenrir");

		starter.addClass(Class.forName("jp.ac.cu.hiroshima.info.cm.nakamura.player.NoriRoleAssignPlayer"),"中村人");
		starter.addClass(Class.forName("com.carlo.aiwolf.sample.player.SamplePlayer"),"carlo_sample");
		//starter.addClass(Class.forName("koizu.MyPlayer"),"koizu");

		starter.addClass(Class.forName("com.gmail.octobersky.MyRoleAssignPlayer"),"昼休み");
		//starter.addClass(Class.forName("com.canvassoft.Agent.CanvasRoleAssignPlayer")); //CanvasSoft //log
		//starter.addClass(Class.forName("jp.ac.cu.hiroshima.inaba.agent.InabaAgent"),"chime");  //log

		System.out.println(starter.getPlayerNum()+"人で"+gameNum+"回ゲームを行います。");
		starter.gameStart(isShowConsoleLog,isSaveLog);
		//結果をコンソールログで表示
		starter.printwinLoseCounterMap();
		//CSVファイルを生成
		starter.writeToCSVFile();

	}

}